<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: streamstatus_panel.php
| Author: Andre Krell (systemweb.de & krelli.com)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) {
    die("Access Denied");
}

if (!checkrights("SWSS") || !defined("iAUTH") || $_GET['aid'] != iAUTH) {
	redirect(BASEDIR . "index.php");
}

if(defined('FUSION_V7')) {
	include(SWSS_LOCALE);
}
else {
	$locale = fusion_get_locale('', SWSS_LOCALE);
	add_breadcrumb(['link' => INFUSIONS.'streamstatus/administration/admin.php'.fusion_get_aidlink(), 'title' => $locale['SSP_100']]);
}
add_to_title($locale['SSP_100']);

$result = dbquery("SELECT * FROM " . DB_STREAMSTATUS_SETTINGS);
if (dbrows($result)) {
    while ($data = dbarray($result)) {
        $ssp_setting[$data['settings_name']] = $data['settings_value'];
    }
}

$section = 'settings';
$section_title = $locale['SSP_101'];
if (IsSet($_GET['section'])) {
	if($_GET['section'] == 'settings') {
        $section = 'settings';
        $section_title = $locale['SSP_101'];
		if(!defined('FUSION_V7')) add_breadcrumb(['link' => FUSION_SELF.$aidlink."&section=settings", 'title' => $section_title]);
	}
	elseif($_GET['section'] == 'channels') {
		$section = 'channels';
        $section_title = $locale['SSP_102'];
		if(!defined('FUSION_V7')) add_breadcrumb(['link' => FUSION_SELF.$aidlink."&section=channels", 'title' => $section_title]);
	}
	elseif($_GET['section'] == 'covers') {
		$section = 'covers';
        $section_title = $locale['SSP_103'];
		if(!defined('FUSION_V7')) add_breadcrumb(['link' => FUSION_SELF.$aidlink."&section=covers", 'title' => $section_title]);
	}
}

if(defined('FUSION_V7')) {
	echo "<table cellpadding='0' cellspacing='0' class='tbl-border' align='center' style='width:auto; margin-bottom:20px; text-align:center;'>\n<tr>\n";
	echo "<td class='" . ($section == "settings" ? "tbl2" : "tbl1") . "'>" . ($section == "settings" ? $locale['SSP_101'] : "<a href='" . FUSION_SELF . $aidlink . "'>" . $locale['SSP_101'] . "</a>") . "</td>\n";
	echo "<td class='" . ($section == "channels" ? "tbl2" : "tbl1") . "'>" . ($section == "channels" ? $locale['SSP_102'] : "<a href='" . FUSION_SELF . $aidlink . "&amp;section=channels'>" . $locale['SSP_102'] . "</a>") . "</td>\n";
	if ($ssp_setting['enable_covers'] == '1') {
		echo "<td class='" . ($section == "covers" ? "tbl2" : "tbl1") . "'>" . ($section == "covers" ? $locale['SSP_103'] : "<a href='" . FUSION_SELF . $aidlink . "&amp;section=covers'>" . $locale['SSP_103'] . "</a>") . "</td>\n";
	}
	echo "</tr>\n</table>\n";
}
else {
	echo "<ul id='link' class='nav nav-tabs'>
	<li class='" . ($section == 'settings' ? 'active' : '') . "'>
		<a class='pointer active' href='" . FUSION_SELF . $aidlink. "&section=settings' role='tab'> " . $locale['SSP_101'] ." </a>
	</li>
	<li class='" . ($section == 'channels' ? 'active' : '') . "'>
		<a class='pointer' href='" . FUSION_SELF . $aidlink. "&section=channels' role='tab'> " . $locale['SSP_102'] ." </a>
	<li class='" . ($section == 'covers' ? 'active' : '') . "'>
		<a class='pointer' href='" . FUSION_SELF . $aidlink. "&section=covers' role='tab'> " . $locale['SSP_103'] ." </a>
	</li>
	</ul>
	";
	opentable($locale['SSP_title'] . " &raquo; " . $section_title);
}

@include(__DIR__ . "/" . $section . ".php");

if(!defined('FUSION_V7')) {
	closetable();
}

