<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: channels.php
| Author: Andre Krell | "Krelli" (systemweb.de | krelli.com)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) {
    die("Access Denied");
}

if (!checkrights("SWSS") || !defined("iAUTH") || $_GET['aid'] != iAUTH) {
    redirect(BASEDIR . "index.php");
}

if(defined('FUSION_V7')) {
	include(SWSS_LOCALE);
}
else {
	$locale = fusion_get_locale('', SWSS_LOCALE);
}

// disable form submit via return key
add_to_head("
<script>
    $(document).ready(function() {
        $(window).keydown(function(event){
            if(event.keyCode == 13) {
                event.preventDefault();
                return false;
            }
        });
    });
</script>
");

// form switcher
$switcher_js = '
<script>
    function switch_streamtype() {
        let inputVal = document.getElementById("stream_type").value;
        document.getElementById("formbuttons").style.display = "none";
        document.getElementById("shoutcast1").style.display = "none";
        document.getElementById("shoutcast2").style.display = "none";
        document.getElementById("icecast").style.display = "none";
        document.getElementById("lautfm").style.display = "none";
        if (inputVal != "") {
			if (inputVal == "stream24") { inputVal = "icecast"; }
            document.getElementById(inputVal).style.display = "block";
            document.getElementById("formbuttons").style.display = "block";
        }
    }
    function switch_scheduler() {
        let inputVal = document.getElementById("stream_scheduler").value;
        document.getElementById("scheduler_form").style.display = "none";
        document.getElementById("scheduler_granade").style.display = "none";
        document.getElementById("scheduler_systemweb").style.display = "none";
        document.getElementById("scheduler_aim").style.display = "none";
        document.getElementById("scheduler_transcoder").style.display = "none";
        document.getElementById("scheduler_azuracast").style.display = "none";
        document.getElementById("scheduler_songtitle").style.display = "none";
        if (inputVal != "") {
            document.getElementById("scheduler_form").style.display = "block";
            document.getElementById("scheduler_" + inputVal).style.display = "block";
        }
    }
    function switch_preview() {
        let inputVal = document.getElementById("stream_defaultcover").value;
        document.getElementById("preview").src="' . INFUSIONS . 'streamstatus_panel/covers/__NO-COVER/" + inputVal;
    }
    switch_streamtype();
    switch_scheduler();
    ' . ($ssp_setting['enable_covers'] == '1' ? "switch_preview();" : "") . '
</script>
';

// check if schedulers from Granade / Systemweb installed
$scheduler_sw = FALSE;
$scheduler_gr = FALSE;
$result = dbquery("SHOW TABLES LIKE '" . DB_PREFIX . "sendeplan'");
if (dbrows($result) == 1) {
    $scheduler_sw = TRUE;
}
$result = dbquery("SHOW TABLES LIKE '" . DB_PREFIX . "gr_sendeplan'");
if (dbrows($result) == 1) {
    $scheduler_gr = TRUE;
}

echo "<div class='admintitle'>" . $locale['SSP_102'] . "</div>\n";

if (isset($_GET['status']) && $_GET['status'] == "edit_success") {
    echo "<div id='close-message'><div class='admin-success'>" . $locale['SSP_114'] . "</div></div>\n";
} elseif (isset($_GET['status']) && $_GET['status'] == "add_success") {
    echo "<div id='close-message'><div class='admin-success'>" . $locale['SSP_115'] . "</div></div>\n";
} elseif (isset($_GET['status']) && $_GET['status'] == "del_success") {
    echo "<div id='close-message'><div class='admin-success'>" . $locale['SSP_116'] . "</div></div>\n";
}

$error = "";

// posts
if (isset($_POST['edit_save']) || isset($_POST['add_save'])) {
    $db_update_row = array();
    // ID
    $channel_id = (isset($_REQUEST['channel_id']) && IsNum($_REQUEST['channel_id']) ? $_REQUEST['channel_id'] : NULL);
	// if add channel then fill current cover to default to prevent errors
	if(isset($_POST['add_save'])) {
		$db_update_row['stream_coverimg'] = "__NO-COVER/DEFAULT_COVER.JPG";
	}
    // stream_title
    if ($_POST['stream_title'] != preg_replace('/[^A-Za-z0-9ÄÖÜäöüßèé@ :.,;()\!\-\&\/]+/', '', $_POST['stream_title'])) {
        $error .= "<li>" . $locale['SSP_230a'] . "</li>";
    } elseif (empty(trim($_POST['stream_title']))) {
        $error .= "<li>" . $locale['SSP_230e'] . "</li>";
    } else {
        $stream_title = $_POST['stream_title'];
        $db_update_row['stream_title'] = trim(stripinput($stream_title));
    }
    // stream_visibility
    $stream_visibility = (isset($_POST['stream_visibility']) && (IsNum($_POST['stream_visibility']) || $_POST['stream_visibility'] == 'guest' || $_POST['stream_visibility'] == 'member' || $_POST['stream_visibility'] == 'admin' || $_POST['stream_visibility'] == 'siteadmin') ? $_POST['stream_visibility'] : '0');
    $db_update_row['stream_visibility'] = trim(stripinput($stream_visibility));
    // stream_description
    if ($_POST['stream_description'] != preg_replace('/[^A-Za-z0-9ÄÖÜäöüßèé@ :.,;()\!\-\&\/]+/', '', $_POST['stream_description'])) {
        $error .= "<li>" . $locale['SSP_230b'] . "</li>";
    } else {
        $stream_description = $_POST['stream_description'];
        $db_update_row['stream_description'] = trim(stripinput($stream_description));
    }
    // stream_standardplayers
    $stream_standardplayers = (isset($_POST['stream_standardplayers']) && $_POST['stream_standardplayers'] == '1' ? '1' : '0');
    $db_update_row['stream_standardplayers'] = trim(stripinput($stream_standardplayers));
    // stream_audioplayer
    if ($_POST['stream_audioplayer'] != preg_replace('/[^A-Za-z0-9@_:.\(\)\-\/\=\?\&]+/', '', $_POST['stream_audioplayer'])) {
        $error .= "<li>" . $locale['SSP_230c'] . "</li>";
    } else {
        $stream_audioplayer = $_POST['stream_audioplayer'];
        $db_update_row['stream_audioplayer'] = trim(stripinput($stream_audioplayer));
    }
    // stream_wishboxlink
    if ($_POST['stream_wishboxlink'] != preg_replace('/[^A-Za-z0-9@_:.\-\/\=\?\&]+/', '', $_POST['stream_wishboxlink'])) {
        $error .= "<li>" . $locale['SSP_230d'] . "</li>";
    } else {
        $stream_wishboxlink = $_POST['stream_wishboxlink'];
        $db_update_row['stream_wishboxlink'] = trim(stripinput($stream_wishboxlink));
    }
    // default cover
    if ($ssp_setting['enable_covers'] == '1') {
        if (empty(trim($_POST['stream_defaultcover']))) {
            $error .= "<li>" . $locale['SSP_230f'] . "</li>";
        } elseif (!file_exists(INFUSIONS . 'streamstatus_panel/covers/__NO-COVER/' . stripinput(trim($_POST['stream_defaultcover'])))) {
            $error .= "<li>" . $locale['SSP_230g'] . "</li>";
        } else {
            $db_update_row['stream_defaultcover'] = stripinput(trim($_POST['stream_defaultcover']));
        }
    }
    // stream_scheduler
    if ($_POST['stream_scheduler'] == 'systemweb') {
        $stream_scheduler = 'systemweb';
    } elseif ($_POST['stream_scheduler'] == 'granade') {
        $stream_scheduler = 'granade';
    } elseif ($_POST['stream_scheduler'] == 'aim') {
        $stream_scheduler = 'aim';
    } elseif ($_POST['stream_scheduler'] == 'azuracast') {
        $stream_scheduler = 'azuracast';
    } elseif ($_POST['stream_scheduler'] == 'songtitle') {
        $stream_scheduler = 'songtitle';
    } elseif ($_POST['stream_scheduler'] == 'transcoder') {
        $stream_scheduler = 'transcoder';
    } else {
        $stream_scheduler = '';
    }
    
    $db_update_row['stream_scheduler'] = trim(stripinput($stream_scheduler));
    // stream_type
    if (empty(trim($_POST['stream_type']))) {
        $error .= "<li>" . $locale['SSP_230h'] . "</li>";
    } elseif ($_POST['stream_type'] != 'shoutcast1' && $_POST['stream_type'] != 'shoutcast2' && $_POST['stream_type'] != 'icecast' && $_POST['stream_type'] != 'stream24' && $_POST['stream_type'] != 'lautfm') {
        $error .= "<li>" . $locale['SSP_230i'] . "</li>";
    } else {
        $stream_type = stripinput(trim($_POST['stream_type']));
        $db_update_row['stream_type'] = trim(stripinput($stream_type));
    }

    $stream_id = 1; // SC 2.x

    if ($stream_type == 'shoutcast1') {
        $stream_server = $_POST['stream_server_sc1'];
        $stream_port = $_POST['stream_port_sc1'];
        $stream_ssl = (isset($_POST['stream_ssl_sc1']) ? $_POST['stream_ssl_sc1'] : "0");
		$stream_adminpw = (isset($_POST['stream_adminpw']) ? $_POST['stream_adminpw'] : "");
		$db_update_row['stream_adminpw'] = trim(stripinput($_POST['stream_adminpw']));
    } elseif ($stream_type == 'shoutcast2') {
        $stream_server = $_POST['stream_server_sc2'];
        $stream_port = $_POST['stream_port_sc2'];
        $stream_ssl = (isset($_POST['stream_ssl_sc2']) ? $_POST['stream_ssl_sc2'] : "0");
        $stream_id = (IsNum($_POST['stream_id']) ? $_POST['stream_id'] : '1');
		$stream_adminpw = (isset($_POST['stream_adminpw_sc2']) ? $_POST['stream_adminpw_sc2'] : "");
		$db_update_row['stream_adminpw'] = trim(stripinput($_POST['stream_adminpw_sc2']));
    } elseif ($stream_type == 'icecast' || $stream_type == 'stream24') {
        $stream_server = $_POST['stream_server_ice'];
        $stream_port = $_POST['stream_port_ice'];
        $stream_ssl = (isset($_POST['stream_ssl_ice']) ? $_POST['stream_ssl_ice'] : "0");
        $stream_mountpoint = stripinput(trim($_POST['stream_mountpoint']));
		$stream_adminpw = (isset($_POST['stream_adminpw_ice']) ? $_POST['stream_adminpw_ice'] : "");
        $db_update_row['stream_mountpoint'] = trim(stripinput($stream_mountpoint));
		$db_update_row['stream_adminpw'] = trim(stripinput($_POST['stream_adminpw_ice']));
    } elseif ($stream_type == 'lautfm') {
        $stream_channelname = stripinput(trim(strtolower($_POST['stream_channelname'])));
    }
    
    // https und http aus Serverangabe entfernen:
    $stream_server = (IsSet($stream_server) && !empty(trim($stream_server)) ? str_replace(array("http://", "https://"), '', $stream_server) : '');
	
	if (IsSet($stream_scheduler) && $stream_scheduler == "aim") {
		if($stream_type != "shoutcast1") {
            $error .= "<li>" . $locale['SSP_230o'] . "</li>";
        }
        /*if(!IsSet($_POST['stream_adminpw']) || $_POST['stream_adminpw'] == '') {
			$error .= "<li>" . $locale['SSP_230x'] . "</li>";
		}
        else {
            $db_update_row['stream_adminpw'] = trim(stripinput($_POST['stream_adminpw']));
        }*/
    }
    if (IsSet($stream_scheduler) && $stream_scheduler == "transcoder") {
		if(!IsSet($_POST['stream_tc_server']) || $_POST['stream_tc_server'] != preg_replace('/[^A-Za-z0-9@_:.\-]+/', '_', $_POST['stream_tc_server'])) {
			$error .= "<li>" . $locale['SSP_230p'] . "</li>";
		}
		else {
			$db_update_row['stream_tc_server'] = trim(stripinput($_POST['stream_tc_server']));
		}
		if(!IsSet($_POST['stream_tc_adminport']) || !IsNum($_POST['stream_tc_adminport']) || $_POST['stream_tc_adminport'] < 1000 || $_POST['stream_tc_adminport'] > 65536) {
			$error .= "<li>" . $locale['SSP_230q'] . "</li>";
		}
		else {
			$db_update_row['stream_tc_adminport'] = intval($_POST['stream_tc_adminport']);
		}
		if(!IsSet($_POST['stream_tc_adminuser']) || $_POST['stream_tc_adminuser'] == '') {
			$error .= "<li>" . $locale['SSP_230r'] . "</li>";
		}
		else {
			$db_update_row['stream_tc_adminuser'] = trim(stripinput($_POST['stream_tc_adminuser']));
		}
		if(!IsSet($_POST['stream_tc_adminpass']) || $_POST['stream_tc_adminpass'] == '') {
			$error .= "<li>" . $locale['SSP_230s'] . "</li>";
		}
		else {
			$db_update_row['stream_tc_adminpass'] = trim(stripinput($_POST['stream_tc_adminpass']));
		}
    }
    elseif (IsSet($stream_scheduler) && $stream_scheduler == "azuracast") {
		if(!IsSet($_POST['stream_ac_autodjname']) || $_POST['stream_ac_autodjname'] != preg_replace('/[^A-Za-z0-9ÄÖÜäöüßèé@ :.,;()\!\-\&\/]+/', '_', $_POST['stream_ac_autodjname'])) {
			$error .= "<li>" . $locale['SSP_230x'] . "</li>";
		}
		else {
            $db_update_row['stream_autodj_name'] = trim(stripinput($_POST['stream_ac_autodjname']));
		}
        if(!IsSet($_POST['stream_ac_server']) || $_POST['stream_ac_server'] != preg_replace('/[^A-Za-z0-9@_:.\/\-]+/', '_', $_POST['stream_ac_server'])) {
			$error .= "<li>" . $locale['SSP_230t'] . "</li>";
		}
		else {
            $protocol = "https://";
            if(substr($_POST['stream_ac_server'], 0, 7) === "http://" || substr($_POST['stream_ac_server'], 0, 8) === "https://") {
                $protocol = "";
            }
			$db_update_row['stream_ac_server'] = $protocol . trim(stripinput($_POST['stream_ac_server']));
		}
		if(!IsSet($_POST['stream_ac_channel']) || !IsNum($_POST['stream_ac_channel'])) {
			$error .= "<li>" . $locale['SSP_230u'] . "</li>";
		}
		else {
			$db_update_row['stream_ac_channel'] = trim(stripinput($_POST['stream_ac_channel']));
		}
		if(!IsSet($_POST['stream_ac_apikey']) || $_POST['stream_ac_apikey'] == '') {
			$error .= "<li>" . $locale['SSP_230v'] . "</li>";
		}
		else {
			$db_update_row['stream_ac_apikey'] = trim(stripinput($_POST['stream_ac_apikey']));
		}
	}
	elseif (IsSet($stream_scheduler) && $stream_scheduler == "songtitle") {
		if(!IsSet($_POST['stream_songspacer']) || trim($_POST['stream_songspacer']) == "" || $_POST['stream_songspacer'] != preg_replace('/[^A-Za-z0-9@_|:.\- ]+/', '_', $_POST['stream_songspacer'])) {
			$error .= "<li>" . $locale['SSP_230w'] . "</li>";
		}
		else {
			$db_update_row['stream_songspacer'] = trim(stripinput($_POST['stream_songspacer']));
		}
    }

    if ($stream_type != 'lautfm') {
        $db_update_row['stream_server'] = trim(stripinput($stream_server));
        $db_update_row['stream_port'] = trim(stripinput($stream_port));
        $db_update_row['stream_ssl'] = trim(stripinput($stream_ssl));
        $db_update_row['stream_id'] = trim(stripinput($stream_id));
        if ($stream_server == "" || $stream_server != preg_replace('/[^A-Za-z0-9@_:.\-]+/', '_', $stream_server)) {
            $error .= "<li>" . $locale['SSP_230m'] . "</li>";
        }
        if (!IsNum($stream_port) || $stream_port < 1000 || $stream_port > 65536) {
            $error .= "<li>" . $locale['SSP_230n'] . "</li>";
        }
        if (($stream_type == 'icecast' || $stream_type == 'stream24') && (empty($stream_mountpoint) || $stream_mountpoint != preg_replace('/[^A-Za-z0-9@_.\-\/]+/', '_', $stream_mountpoint))) {
            $error .= "<li>" . $locale['SSP_230j'] . "</li>";
        }
        if ($stream_type == 'shoutcast2' && (!IsNum($stream_id) || $stream_id < 1 || $stream_id > 999)) {
            $error .= "<li>" . $locale['SSP_230k'] . "</li>";
        }
    } else {
        if (empty(trim($stream_channelname)) || $stream_channelname != preg_replace('/[^A-Za-z0-9@_:.\-]+/', '_', $stream_channelname)) {
            $error .= "<li>" . $locale['SSP_230l'] . "</li>";
        }
        $db_update_row['stream_channelname'] = trim(stripinput($stream_channelname));
    }

    if (empty($error)) {
        if (isset($_POST['edit_save'])) {
            $do_update = "";
            foreach ($db_update_row as $key => $item) {
                $do_update .= (isset($second_item) ? ",\n" : "");
                $do_update .= "`" . $key . "` = '" . $item . "'";
                $second_item = TRUE;
            }
            $result = dbquery("UPDATE `" . DB_STREAMSTATUS_STREAMS . "` SET " . $do_update . " WHERE `ID` = " . $channel_id . " LIMIT 1;");
            redirect(FUSION_SELF . $aidlink . "&section=channels&status=edit_success");
        } elseif (isset($_POST['add_save'])) {
            $dbinsert_fields = "";
            $dbinsert_values = "";
            foreach ($db_update_row as $key => $item) {
                $dbinsert_fields .= (isset($second_item) ? ", " : "") . "`" . $key . "`";
                $dbinsert_values .= (isset($second_item) ? ", " : "") . "'" . $item . "'";
                $second_item = TRUE;
            }
            $sql_q = "INSERT INTO `" . DB_STREAMSTATUS_STREAMS . "` (" . $dbinsert_fields . ") VALUES (" . $dbinsert_values . ");";
            $result = dbquery($sql_q);
            redirect(FUSION_SELF . $aidlink . "&section=channels&status=add_success");
        }
        exit;
    }
}

// delete channel, need to confirm
if (isset($_REQUEST['action']) && $_REQUEST['action'] == "delete" && isset($_REQUEST['channel_id']) && IsNum($_REQUEST['channel_id'])) {
    $result = dbquery("SELECT `ID`, `stream_title` FROM `" . DB_STREAMSTATUS_STREAMS . "` WHERE `ID` = " . $_REQUEST['channel_id'] . ";");
    $rows = dbrows($result);
    if ($rows == 0) {
        redirect(FUSION_SELF . $aidlink . '&amp;section=channels');
        exit;
    } else {
        $channel = dbarray($result);
    }
    echo '    
    <div class="ss-adminform">
        <div style="text-align: center; padding: 10pt;">[ <a name="new_channel" id="new_channel" href="' . FUSION_SELF . $aidlink . '&section=channels">&laquo; ' . $locale['SSP_214'] . '</a> ]</div>
        <div style="text-align: center; font-size: 12pt; padding: 10px;">' . $locale['SSP_213'] . '</div>
        <div class="tbl-border" style="width: 300px; margin: 0 auto; font-size: 10pt; border-spacing: 0;">
            <div class="tbl-header">' . $locale['SSP_215'] . '</div>
            <div class="tbl1" style="text-align: center;">' . sprintf($locale['SSP_216'], $channel['stream_title']) . '</div>
        </div>
        <div style="text-align: center; padding: 10pt;"><button class="button" style="cursor: pointer;" name="del_confirm" onclick="window.location.href=\'' . FUSION_SELF . $aidlink . '&section=channels&action=delete_confirmed&channel_id=' . $channel['ID'] . '\';">' . $locale['SSP_217'] . '</button></div>
    </div>
	';
}

// delete channel, confirmed
elseif (isset($_REQUEST['action']) && $_REQUEST['action'] == "delete_confirmed" && isset($_REQUEST['channel_id']) && IsNum($_REQUEST['channel_id'])) {
    $result = @dbquery("DELETE FROM `" . DB_STREAMSTATUS_STREAMS . "` WHERE `ID` = " . $_REQUEST['channel_id'] . " LIMIT 1;");
    redirect(FUSION_SELF . $aidlink . "&section=channels&status=del_success");
    exit;
}

// edit channel
elseif (isset($_REQUEST['action']) && ($_REQUEST['action'] == "edit" || $_REQUEST['action'] == "add")) {
    if ($_REQUEST['action'] == "edit" && (!isset($_REQUEST['channel_id']) || !IsNum($_REQUEST['channel_id']))) {
        redirect(FUSION_SELF . $aidlink . '&section=channels');
        exit;
    } elseif (isset($_REQUEST['channel_id'])) {
        $channel_id = $_REQUEST['channel_id'];
    }

    if ($_REQUEST['action'] == "edit") {
        $result = dbquery("SELECT * FROM `" . DB_STREAMSTATUS_STREAMS . "` WHERE `ID` = " . $channel_id . ";");
        $rows = dbrows($result);
        if ($rows == 0) {
            redirect(FUSION_SELF . $aidlink . '&section=channels');
            exit;
        } else {
            $channel = dbarray($result);
        }
    }
    // define form elements for "DJ on Air"
    $scheduler_options = "<option value=''" . (($_REQUEST['action'] == "edit" && !isset($_POST['stream_scheduler']) && $channel['stream_scheduler'] == '') || (isset($_POST['stream_scheduler']) && $_POST['stream_scheduler'] == '') ? " selected" : "") . ">- deaktiviert -</option>\n";
	// Granade not implemented yet
    /*$scheduler_options .= "<option value='granade'" . (($_REQUEST['action'] == "edit" && !isset($_POST['stream_scheduler']) && $channel['stream_scheduler'] == 'granade') || (isset($_POST['stream_scheduler']) && $_POST['stream_scheduler'] == 'granade') ? " selected" : "") . ">" . $locale['SSP_208b'] . "</option>\n";*/
    $scheduler_options .= "<option value='systemweb'" . (($_REQUEST['action'] == "edit" && !isset($_POST['stream_scheduler']) && $channel['stream_scheduler'] == 'systemweb') || (isset($_POST['stream_scheduler']) && $_POST['stream_scheduler'] == 'systemweb') ? " selected" : "") . ">" . $locale['SSP_208a'] . "</option>\n";
    $scheduler_options .= "<option value='azuracast'" . (($_REQUEST['action'] == "edit" && !isset($_POST['stream_scheduler']) && $channel['stream_scheduler'] == 'azuracast') || (isset($_POST['stream_scheduler']) && $_POST['stream_scheduler'] == 'azuracast') ? " selected" : "") . ">" . $locale['SSP_208c'] . "</option>\n";
    $scheduler_options .= "<option value='transcoder'" . (($_REQUEST['action'] == "edit" && !isset($_POST['stream_scheduler']) && $channel['stream_scheduler'] == 'transcoder') || (isset($_POST['stream_scheduler']) && $_POST['stream_scheduler'] == 'transcoder') ? " selected" : "") . ">" . $locale['SSP_208d'] . "</option>\n";
    $scheduler_options .= "<option value='aim'" . (($_REQUEST['action'] == "edit" && !isset($_POST['stream_scheduler']) && $channel['stream_scheduler'] == 'aim') || (isset($_POST['stream_scheduler']) && $_POST['stream_scheduler'] == 'aim') ? " selected" : "") . ">" . $locale['SSP_208e'] . "</option>\n";
    $scheduler_options .= "<option value='songtitle'" . (($_REQUEST['action'] == "edit" && !isset($_POST['stream_scheduler']) && $channel['stream_scheduler'] == 'songtitle') || (isset($_POST['stream_scheduler']) && $_POST['stream_scheduler'] == 'songtitle') ? " selected" : "") . ">" . $locale['SSP_208f'] . "</option>\n";

    // define form elements for stream visibility
    $group_options = '';
    $result = dbquery("SELECT `group_id`, `group_name` FROM `" . DB_USER_GROUPS . "` ORDER BY `group_name` ASC;");
    $rows = dbrows($result);
    if ($rows > 0) {
        while ($g_data = dbarray($result)) {
            $group_options .= "<option value='" . $g_data['group_id'] . "'" . ((isset($_POST['stream_visibility']) && $_POST['stream_visibility'] == $g_data['group_id']) || ($_REQUEST['action'] == "edit" && !isset($_POST['stream_visibility']) && $channel['stream_visibility'] == $g_data['group_id']) ? " selected='selected'" : "") . ">" . $locale['SSP_105c'] . ": " . $g_data['group_name'] . "</option>
        ";
        }
    }

    // define form elements for default cover
    $defaultcover_options = '';
    $cover_dir = openDir(INFUSIONS . "streamstatus_panel/covers/__NO-COVER/");
    while ($file = readDir($cover_dir)) {
        /* 
                All filenames including filename extensions may not contain lowercase letters !!!
                Wrong: Image1.jpg, IMAGE1.jpg, Image1.JPG
                Right: IMAGE1.JPG
        */
        if ($file != "." && $file != ".." && (strstr($file, ".JPG") || strstr($file, ".JPG") || strstr($file, ".PNG") || strstr($file, ".GIF") || strstr($file, ".SVG")) && $file == strtoupper($file)) {
            $defaultcover_options .= "<option value='" . $file . "'" . ((!isset($_POST['stream_defaultcover']) && IsSet($channel['stream_defaultcover']) && $channel['stream_defaultcover'] == $file) || (isset($_POST['stream_defaultcover']) && $_POST['stream_defaultcover'] == $file) ? " selected" : "") . ">" . $file . "</option>\n";
        }
    }

    // Display errors or status
    if (!empty($error)) {
        echo "
    <div class='admin-error'>
        " . $locale['SSP_113'] . ":
        <ul>
            " . $error . "
        </ul>
    </div>\n";
    }

    echo '    
    <div class="ss-adminform">
        <div style="text-align: center; padding: 10pt;">[ <a name="new_channel" id="new_channel" href="' . FUSION_SELF . $aidlink . '&section=channels">&laquo; ' . $locale['SSP_214'] . '</a> ]</div>
        <div style="text-align: center; font-size: 12pt; padding: 10px;">' . ($_REQUEST['action'] == "edit" ? $locale['SSP_200'] : $locale['SSP_212']) . '</div>
        <div class="">
            <div class="card shadow mb-4">
            <div>
                <form name="edit_channel" method="post">
                <table class="tbl-border" style="width: 300px; margin: 0 auto; font-size: 10pt; border-spacing: 0;">
                    <tbody>
                        <tr>
                            <td class="tbl-header" colspan="2">' . $locale['SSP_201'] . '</td>
                        </tr>
                        <tr>
                            <td class="tbl1" style="width: 50%;">' . $locale['SSP_202'] . '</td>
                            <td class="tbl1"><input name="stream_title" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_title']) ? $_POST['stream_title'] : ($_REQUEST['action'] == "edit" ? $channel['stream_title'] : '')) . '" maxlength="50"></td>
                        </tr>
                        <tr>
                            <td class="tbl2">' . $locale['SSP_203'] . '</td>
                            <td class="tbl2"><input name="stream_description" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_description']) ? $_POST['stream_description'] : ($_REQUEST['action'] == "edit" ? $channel['stream_description'] : '')) . '" maxlength="100"><br><span class="small">' . $locale['SSP_203a'] . '</span></td>
                        </tr>
                        <tr>
                            <td class="tbl1">' . $locale['SSP_204'] . '</td>
                            <td class="tbl1">
                                <select name="stream_visibility" class="textbox" style="width: 160px;">
                                    <option value="guest"' . ((isset($_POST['stream_visibility']) && $_POST['stream_visibility'] == 'guest') || ($_REQUEST['action'] == "edit" && !isset($_POST['stream_visibility']) && $channel['stream_visibility'] == 'guest') ? " selected='selected'" : "") . '>' . $locale['SSP_105a'] . '</option>
                                    <option value="member"' . ((isset($_POST['stream_visibility']) && $_POST['stream_visibility'] == 'member') || ($_REQUEST['action'] == "edit" && !isset($_POST['stream_visibility']) && $channel['stream_visibility'] == 'member') ? " selected='selected'" : "") . '>' . $locale['SSP_105b'] . '</option>
                                    ' . $group_options . '
                                    <option value="admin"' . ((isset($_POST['stream_visibility']) && $_POST['stream_visibility'] == 'admin') || ($_REQUEST['action'] == "edit" && !isset($_POST['stream_visibility']) && $channel['stream_visibility'] == 'admin') ? " selected='selected'" : "") . '>' . $locale['SSP_105d'] . '</option>
                                    <option value="siteadmin"' . ((isset($_POST['stream_visibility']) && $_POST['stream_visibility'] == 'sitadmin') || ($_REQUEST['action'] == "edit" && !isset($_POST['stream_visibility']) && $channel['stream_visibility'] == 'siteadmin') ? " selected='selected'" : "") . '>' . $locale['SSP_105e'] . '</option>                                    
                                </select>
                            </td>
                        </tr>
                        <tr>
                            <td class="tbl2">' . $locale['SSP_205'] . '<br/><span class="small">' . $locale['SSP_205a'] . '</span></td>
                            <td class="tbl2">
                                <input type="radio" id="stream_standardplayers1" name="stream_standardplayers" value="1"' .
								(($_REQUEST['action'] == "edit" && !isset($_POST['stream_standardplayers']) && $channel['stream_standardplayers'] != '0') || (isset($_POST['stream_standardplayers']) && $_POST['stream_standardplayers'] != '0') ? ' checked="checked"' : '') . '>
                                <label for="stream_standardplayers1">' . $locale['SSP_205b'] . '</label><br>
                                <input type="radio" id="stream_standardplayers2" name="stream_standardplayers" value="0"' .
								(($_REQUEST['action'] == "edit" && !isset($_POST['stream_standardplayers']) && $channel['stream_standardplayers'] == '0') || (isset($_POST['stream_standardplayers']) && $_POST['stream_standardplayers'] == '0') ? ' checked="checked"' : '') . '>
                                <label for="stream_standardplayers2">' . $locale['SSP_205c'] . '</label><br>  
                            </td>
                        </tr>
                        <tr>
                            <td class="tbl1">' . $locale['SSP_206'] . '<br /><span class="small">' . $locale['SSP_206a'] . '</span></td>
                            <td class="tbl1"><input name="stream_audioplayer" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_audioplayer']) ? $_POST['stream_audioplayer'] : ($_REQUEST['action'] == "edit" ? $channel['stream_audioplayer'] : '')) . '" maxlength="150"><br /><span class="small">' . $locale['SSP_206b'] . '</span></td>
                        </tr>
                        <tr>
                            <td class="tbl2">' . $locale['SSP_207'] . '</td>
                            <td class="tbl2"><input name="stream_wishboxlink" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_wishboxlink']) ? $_POST['stream_wishboxlink'] : ($_REQUEST['action'] == "edit" ? $channel['stream_wishboxlink'] : '')) . '" maxlength="150"><br /><span class="small">' . $locale['SSP_207a'] . '</span></td>
                        </tr>
                        ' . ($ssp_setting['enable_covers'] == '1' ? '<tr>
                            <td class="tbl1">' . $locale['SSP_209'] . '</td>
                            <td class="tbl1">
                                <select id="stream_defaultcover" name="stream_defaultcover" class="textbox" onChange="switch_preview();">
                                    ' . $defaultcover_options . '
                                </select>
                            </td>
                        </tr>
                        <tr>
                            <td class="tb1">
                                <span class="small">' . $locale['SSP_112a'] . '</span>
                            </td>
                            <td class="tbl1" style="text-align: center;">
                                <img id="preview" style="max-width: 160px; border: 0;" src="' . INFUSIONS . 'streamstatus_panel/covers/__NO-COVER/' . 
                                (IsSet($channel['stream_defaultcover']) ? $channel['stream_defaultcover'] : 'DEFAULT-COVER.JPG') . '" alt="default cover">
                            </td>
                        </tr>
                        ' : '') . '
                        <tr>
                            <td class="tbl-header" colspan="2"><br>' . $locale['SSP_210'] . '</td>
                        </tr>
                        <tr>
                            <td class="tbl2">' . $locale['SSP_211'] . '</td>
                            <td class="tbl2">
                                <select name="stream_type" id="stream_type" class="textbox" style="width: 150px;" onChange="switch_streamtype();">
                                    <option value="">' . $locale['SSP_211a'] . '</option>
                                    <option value="shoutcast1"' . 
									(($_REQUEST['action'] == "edit" && !isset($_POST['stream_type']) && $channel['stream_type'] == "shoutcast1") || (isset($_POST['stream_type']) && $_POST['stream_type'] == "shoutcast1") ? ' selected' : '') . '>Shoutcast 1.x</option>
                                    <option value="shoutcast2"' . 
									(($_REQUEST['action'] == "edit" && !isset($_POST['stream_type']) && $channel['stream_type'] == "shoutcast2") || (isset($_POST['stream_type']) && $_POST['stream_type'] == "shoutcast2") ? ' selected' : '') . '>Shoutcast 2.x</option>
                                    <option value="icecast"' . 
									(($_REQUEST['action'] == "edit" && !isset($_POST['stream_type']) && $channel['stream_type'] == "icecast") || (isset($_POST['stream_type']) && $_POST['stream_type'] == "icecast") ? ' selected' : '') . '>Icecast 2 (Standard)</option>
                                    <option value="lautfm"' . 
									(($_REQUEST['action'] == "edit" && !isset($_POST['stream_type']) && $channel['stream_type'] == "lautfm") || (isset($_POST['stream_type']) && $_POST['stream_type'] == "lautfm") ? ' selected' : '') . '>Icecast 2 (Laut.FM)</option>
									<option value="stream24"' . 
									(($_REQUEST['action'] == "edit" && !isset($_POST['stream_type']) && $channel['stream_type'] == "stream24") || (isset($_POST['stream_type']) && $_POST['stream_type'] == "stream24") ? ' selected' : '') . '>Icecast 2 (Stream24)</option>
                                </select>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="2" style="padding: 0;">
                                <div id="shoutcast1" style="display:none; padding: 0;">
                                    <table style="margin:0; padding: 0; border: 0; border-spacing: 0;">
                                        <tr>
                                            <td class="tbl1">' . $locale['SSP_220'] . '<br /><span class="small">' . $locale['SSP_220a'] . '</span></td>
                                            <td class="tbl1"><input name="stream_server_sc1" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_server_sc1']) ? $_POST['stream_server_sc1'] : ($_REQUEST['action'] == "edit" ? $channel['stream_server'] : '')) . '" maxlength="150"></td>
                                        </tr>
                                        <tr style="padding: 0; margin: 0;">
                                            <td class="tbl2">' . $locale['SSP_221'] . '</td>
                                            <td class="tbl2"><input name="stream_port_sc1" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_port_sc1']) ? $_POST['stream_port_sc1'] : ($_REQUEST['action'] == "edit" ? $channel['stream_port'] : '')) . '" maxlength="5"></td>
                                        </tr>
                                        <tr>
                                            <td class="tbl1">' . $locale['SSP_222'] . '</td>
                                            <td class="tbl1">
                                                <input type="radio" id="stream_ssl_sc1_yes" name="stream_ssl_sc1" value="1"' . (($_REQUEST['action'] == "edit" && !isset($_POST['stream_ssl_sc1']) && $channel['stream_ssl'] != '0') || (isset($_POST['stream_ssl_sc1']) && $_POST['stream_ssl_sc1'] != '0') ? ' checked="checked"' : '') . '>
                                                <label for="stream_ssl_sc1_yes">' . $locale['SSP_222a'] . '</label><br>
                                                <input type="radio" id="stream_ssl_sc1_no" name="stream_ssl_sc1" value="0"' . (($_REQUEST['action'] == "edit" && !isset($_POST['stream_ssl_sc1']) && $channel['stream_ssl'] == '0') || (isset($_POST['stream_ssl_sc1']) && $_POST['stream_ssl_sc1'] == '0') ? ' checked="checked"' : '') . '>
                                                <label for="stream_ssl_sc1_no">' . $locale['SSP_222b'] . '</label>
                                            </td>
                                        </tr>
										<tr>
											<td class="tbl2">' . $locale['SSP_228a'] . '</td>
											<td class="tbl2"><input name="stream_adminpw" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_adminpw']) ? $_POST['stream_adminpw'] : ($_REQUEST['action'] == "edit" ? $channel['stream_adminpw'] : '')) . '" maxlength="25"></td>
										</tr>
									</table>
                                </div>
                                <div id="shoutcast2" style="display:none;">
                                    <table style="margin:0; padding: 0; border: 0; border-spacing: 0;">
                                        <tr>
                                            <td class="tbl1">' . $locale['SSP_220'] . '<br /><span class="small">' . $locale['SSP_220a'] . '</td>
                                            <td class="tbl1"><input name="stream_server_sc2" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_server_sc2']) ? $_POST['stream_server_sc2'] : ($_REQUEST['action'] == "edit" ? $channel['stream_server'] : '')) . '" maxlength="150"></td>
                                        </tr>
                                        <tr style="padding: 0; margin: 0;">
                                            <td class="tbl2">' . $locale['SSP_221'] . '</td>
                                            <td class="tbl2"><input name="stream_port_sc2" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_port_sc2']) ? $_POST['stream_port_sc2'] : ($_REQUEST['action'] == "edit" ? $channel['stream_port'] : '')) . '" maxlength="5"></td>
                                        </tr>
                                        <tr>
                                            <td class="tbl1">' . $locale['SSP_222'] . '</td>
                                            <td class="tbl1">
                                                <input type="radio" id="stream_ssl_sc2_yes" name="stream_ssl_sc2" value="1"' . (($_REQUEST['action'] == "edit" && !isset($_POST['stream_ssl_sc2']) && $channel['stream_ssl'] != '0') || (isset($_POST['stream_ssl_sc2']) && $_POST['stream_ssl_sc2'] != '0') ? ' checked="checked"' : '') . '>
                                                <label for="stream_ssl_sc2_yes">' . $locale['SSP_222a'] . '</label><br>
                                                <input type="radio" id="stream_ssl_sc2_no" name="stream_ssl_sc2" value="0"' . (($_REQUEST['action'] == "edit" && !isset($_POST['stream_ssl_sc2']) && $channel['stream_ssl'] == '0') || (isset($_POST['stream_ssl_sc2']) && $_POST['stream_ssl_sc2'] == '0') ? ' checked="checked"' : '') . '>
                                                <label for="stream_ssl_sc2_no">' . $locale['SSP_222b'] . '</label>
                                            </td>
                                        </tr>
                                        <tr style="padding: 0; margin: 0;">
                                            <td class="tbl2">' . $locale['SSP_223'] . '<br /><span class="small">' . $locale['SSP_223a'] . '</span></td>
                                            <td class="tbl2"><input name="stream_id" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_id']) ? $_POST['stream_id'] : ($_REQUEST['action'] == "edit" ? $channel['stream_id'] : '')) . '" maxlength="3"></td>
                                        </tr>
										<tr>
											<td class="tbl1">' . $locale['SSP_228a'] . '</td>
											<td class="tbl1"><input name="stream_adminpw_sc2" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_adminpw_sc2']) ? $_POST['stream_adminpw_sc2'] : ($_REQUEST['action'] == "edit" ? $channel['stream_adminpw'] : '')) . '" maxlength="25"></td>
										</tr>
									</table>
                                </div>
                                <div id="icecast" style="display:none;">
                                    <table style="margin:0; padding: 0; border: 0; border-spacing: 0;">
                                        <tr>
                                            <td class="tbl1">' . $locale['SSP_220'] . '<br /><span class="small">' . $locale['SSP_220a'] . '</span></td>
                                            <td class="tbl1"><input name="stream_server_ice" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_server_ice']) ? $_POST['stream_server_ice'] : ($_REQUEST['action'] == "edit" ? $channel['stream_server'] : '')) . '" maxlength="150"></td>
                                        </tr>
                                        <tr style="padding: 0; margin: 0;">
                                            <td class="tbl2">' . $locale['SSP_221'] . '</td>
                                            <td class="tbl2"><input name="stream_port_ice" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_port_ice']) ? $_POST['stream_port_ice'] : ($_REQUEST['action'] == "edit" ? $channel['stream_port'] : '')) . '" maxlength="5"></td>
                                        </tr>
                                        <tr style="padding: 0; margin: 0;">
                                            <td class="tbl1">' . $locale['SSP_224'] . '</td>
                                            <td class="tbl1"><input name="stream_mountpoint" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_mountpoint']) ? $_POST['stream_mountpoint'] : ($_REQUEST['action'] == "edit" ? $channel['stream_mountpoint'] : '')) . '" maxlength="50"><br />
                                            <span class="small">' . $locale['SSP_224a'] . '</span></td>
                                        </tr>
                                        
                                        <tr>
                                            <td class="tbl2">' . $locale['SSP_222'] . '</td>
                                            <td class="tbl2">
                                                <input type="radio" id="stream_ssl_ice_yes" name="stream_ssl_ice" value="1"' .                                (($_REQUEST['action'] == "edit" && !isset($_POST['stream_ssl_ice']) && $channel['stream_ssl'] != '0') || (isset($_POST['stream_ssl_ice']) && $_POST['stream_ssl_ice'] != '0') ? ' checked="checked"' : '') . '>
                                                <label for="stream_ssl_ice_yes">' . $locale['SSP_222a'] . '</label><br>
                                                <input type="radio" id="stream_ssl_ice_no" name="stream_ssl_ice" value="0"' .                                (($_REQUEST['action'] == "edit" && !isset($_POST['stream_ssl_ice']) && $channel['stream_ssl'] == '0') || (isset($_POST['stream_ssl_ice']) && $_POST['stream_ssl_ice'] == '0') ? ' checked="checked"' : '') . '>
                                                <label for="stream_ssl_ice_no">' . $locale['SSP_222b'] . '</label>
                                            </td>
                                        </tr>
										<tr>
											<td class="tbl1">' . $locale['SSP_228a'] . '</td>
											<td class="tbl1"><input name="stream_adminpw_ice" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_adminpw_ice']) ? $_POST['stream_adminpw_ice'] : ($_REQUEST['action'] == "edit" ? $channel['stream_adminpw'] : '')) . '" maxlength="25"></td>
										</tr>
                                    </table>
                                </div>
                                <div id="lautfm" style="display:none;">
                                    <table style="width: 100%; margin:0; padding: 0; border: 0; border-spacing: 0;">
                                        <tr>
                                            <td class="tbl1" style="width: 100%;">' . $locale['SSP_225'] . '</td>
                                            <td class="tbl1"><input name="stream_channelname" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_channelname']) ? $_POST['stream_channelname'] : ($_REQUEST['action'] == "edit" ? $channel['stream_channelname'] : '')) . '" maxlength="150"></td>
                                        </tr>
                                    </table>
                                </div>
                            </td>
                        </tr>
                        <tr>
                            <td class="tbl-header" colspan="2"><br>' . $locale['SSP_227'] . '</td>
                        </tr>
                        <tr>
                            <td class="tbl2">' . $locale['SSP_208'] . '</td>
                            <td class="tbl2">
                                <select name="stream_scheduler" id="stream_scheduler" class="textbox" style="width: 160px;" onChange="switch_scheduler();">
                                    ' . $scheduler_options . '
                                </select>
                            </td>
                        </tr>
                        <tr>
                            <td class="tbl1" colspan="2" style="padding: 0;">
                                <div id="scheduler_form" style="display:none; padding: 0;">
                                    <div id="scheduler_aim" style="display: none; padding: 0px;">
                                    	<div style="padding: 10px;">' . $locale['SSP_228'] . '</div>
                                    </div>
                                    <div id="scheduler_granade" style="display: none; padding: 5px;">
                                    	' . ($scheduler_gr ? $locale['SSP_208g'] : '<div class="admin-error">' . $locale['SSP_208h'] . '</div>') . '
                                    </div>
                                    <div id="scheduler_systemweb" style="display: none; padding: 5px;">
                                    	<div>' . ($scheduler_sw ? $locale['SSP_208i'] : '<div class="admin-error">' . $locale['SSP_208j'] . '</div>') . '</div>
                                    </div>
                                    <div id="scheduler_transcoder" style="display: none; padding: 0;">
                                    	<table style="width: 100%; margin: 0; padding: 0; border: 0; border-spacing: 0;">
                                        	<tr>
                                            	<td class="tbl1" style="width: 100%;">' . $locale['SSP_229a'] . '</td>
                                            	<td class="tbl1"><input name="stream_tc_server" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_tc_server']) ? $_POST['stream_tc_server'] : ($_REQUEST['action'] == "edit" ? $channel['stream_tc_server'] : '')) . '" maxlength="150"></td>
                                        	</tr>
                                        	<tr>
                                            	<td class="tbl2">' . $locale['SSP_229b'] . '<br><span class="small">(1000 - 65536)</span></td>
                                            	<td class="tbl2"><input name="stream_tc_adminport" class="textbox" style="width: 60px;" value="' . (isset($_POST['stream_tc_adminport']) ? $_POST['stream_tc_adminport'] : ($_REQUEST['action'] == "edit" ? $channel['stream_tc_adminport'] : '')) . '" maxlength="5"></td>
                                        	</tr>
                                        	<tr>
                                            	<td class="tbl1">' . $locale['SSP_229c'] . '</td>
                                            	<td class="tbl1"><input name="stream_tc_adminuser" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_tc_adminuser']) ? $_POST['stream_tc_adminuser'] : ($_REQUEST['action'] == "edit" ? $channel['stream_tc_adminuser'] : '')) . '" maxlength="50"></td>
                                        	</tr>
                                        	<tr>
                                            	<td class="tbl2">' . $locale['SSP_229d'] . '</td>
                                            	<td class="tbl2"><input name="stream_tc_adminpass" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_tc_adminuser']) ? $_POST['stream_tc_adminpass'] : ($_REQUEST['action'] == "edit" ? $channel['stream_tc_adminpass'] : '')) . '" maxlength="50"></td>
                                        	</tr>
                                        </table>
                                    </div>
                                    <div id="scheduler_azuracast" style="display: none; padding: 0;">
                                    	<table style="width: 100%; margin: 0; padding: 0; border: 0; border-spacing: 0;">
                                        	<tr>
                                            	<td class="tbl1">' . $locale['SSP_229j'] . '</td>
                                            	<td class="tbl1"><input name="stream_ac_autodjname" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_ac_autodjname']) ? $_POST['stream_ac_autodjname'] : ($_REQUEST['action'] == "edit" ? $channel['stream_autodj_name'] : '')) . '" maxlength="50"></td>
                                        	</tr>
                                        	<tr>
                                            	<td class="tbl2" style="width: 100%;">' . $locale['SSP_229e'] . '</td>
                                            	<td class="tbl2"><input name="stream_ac_server" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_ac_server']) ? $_POST['stream_ac_server'] : ($_REQUEST['action'] == "edit" ? $channel['stream_ac_server'] : '')) . '" maxlength="150"><br>
                                                <span class="small">' . $locale['SSP_229k'] . '</span></td>
                                        	</tr>
                                            <tr>
                                            	<td class="tbl1">' . $locale['SSP_229f'] . '</td>
                                            	<td class="tbl1"><input name="stream_ac_channel" class="textbox" style="width: 60px;" value="' . (isset($_POST['stream_ac_channel']) ? $_POST['stream_ac_channel'] : ($_REQUEST['action'] == "edit" ? $channel['stream_ac_channel'] : '')) . '" maxlength="60"></td>
                                        	</tr>
                                        	<tr>
                                            	<td class="tbl2" colspan="2">
                                            		<span class="small">' . $locale['SSP_229h'] . '</span>
                                            	</td>
                                            </tr>
                                        	<tr>
                                            	<td class="tbl1">' . $locale['SSP_229g'] . '</td>
                                            	<td class="tbl1"><input name="stream_ac_apikey" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_ac_apikey']) ? $_POST['stream_ac_apikey'] : ($_REQUEST['action'] == "edit" ? $channel['stream_ac_apikey'] : '')) . '" maxlength="150"></td>
                                        	</tr>
                                        	<tr>
                                            	<td class="tbl2" colspan="2">
                                            		<span class="small">' . $locale['SSP_229i'] . '</span>
                                            	</td>
                                            </tr>
                                        </table>
                                    </div>
                                    <div id="scheduler_songtitle" style="display: none; padding: 0;">
                                    	<table style="width: 100%; margin: 0; padding: 0; border: 0; border-spacing: 0;">
                                        	<tr>
                                            	<td class="tbl1" style="width: 100%;">' . $locale['SSP_227a'] . '<br /><span class="small">' . $locale['SSP_227b'] . '</span></td>
                                            	<td class="tbl1"><input name="stream_songspacer" class="textbox" style="width: 160px;" value="' . (isset($_POST['stream_songspacer']) ? $_POST['stream_songspacer'] : ($_REQUEST['action'] == "edit" ? $channel['stream_songspacer'] : '')) . '" maxlength="150"><br>
                                            	<span class="small">' . $locale['SSP_227c'] . '</span></td>
                                        	</tr>
                                        </table>
                                    </div>
                                </div>
                            </td>
                        </tr>
                    </tbody>
                </table>
                <div id="formbuttons"><input name="' . ($_REQUEST['action'] == 'edit' ? 'edit_save' : 'add_save') . '" type="submit" value="' . $locale['SSP_226'] . '" class="button" style="cursor: pointer;"></div>
                </form>
            </div>
        </div>
    </div>
</div>
';
    add_to_footer($switcher_js);
}

// default view
elseif (!isset($_REQUEST['action']) || ($_REQUEST['action'] != "delete" && $_REQUEST['action'] != "edit"  && $_REQUEST['action'] != "add")) {
    // list of available channels
    echo '    
    <div class="ss-adminform">
        <div style="text-align: center; padding: 10pt;">[ <a name="new_channel" id="new_channel" href="' . FUSION_SELF . $aidlink . '&section=channels&amp;action=add">&plus; ' . $locale['SSP_212'] . '</a> ]</div>
        <div style="text-align: center; font-size: 12pt; padding: 10px;">' . $locale['SSP_218'] . '</div>
        <div class="">
            <div class="card shadow mb-4">
            <div>
                <table class="tbl-border" style="width: 300px; margin: 0 auto; font-size: 10pt;">
                    <thead>
                        <tr>
                            <td class="tbl-header">' . $locale['SSP_202'] . '</td>
                            <td class="tbl-header">' . $locale['SSP_219'] . '</td>
                        </tr>
                    </thead>
                <tbody>';
    $result = dbquery("SELECT * FROM `" . DB_STREAMSTATUS_STREAMS . "` ORDER BY `ID` ASC");
    $z = 0;
    while ($channel = dbarray($result)) {
        $z++;
        $tblclass = "tbl1";
        if ($z % 2 != 0) {
            $tblclass = "tbl2";
        }
        echo '
                    <tr>
                        <td class="' . $tblclass . ' text-nowrap text-left"><i class="fas fa-music"></i> ' . $channel['stream_title'] . '</td>
                        <td width="1" class="' . $tblclass . '" style="white-space: nowrap;">
                            <a href="' . FUSION_SELF . $aidlink . '&section=channels&action=edit&channel_id=' . $channel['ID'] . '" class="btn btn-primary btn-sm text-nowrap"><i class="fa fa-edit"></i> ' . $locale['SSP_219a'] . '</a>
                            <a href="' . FUSION_SELF . $aidlink . '&section=channels&action=delete&channel_id=' . $channel['ID'] . '" class="btn btn-danger btn-sm text-nowrap"><i class="far fa-trash-alt"></i> ' . $locale['SSP_219b'] . '</a>
                        </td>
                    </tr>';
    }
    echo '            
                </tbody>
            </table>
        </div>
    </div>
</div>
</div>
';
}
