<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: covers.php
| Author: Andre Krell (systemweb.de & krelli.com)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) {
  die("Access Denied");
}

if (!checkrights("SWSS") || !defined("iAUTH") || $_GET['aid'] != iAUTH) {
  redirect(BASEDIR . "index.php");
}

if(defined('FUSION_V7')) {
	include(SWSS_LOCALE);
}
else {
	$locale = fusion_get_locale('', SWSS_LOCALE);
}

require_once(__DIR__ . "/../../includes/ss_functions.php");

echo "<div class='admintitle'>" . $locale['SSP_103'] . "</div>\n";

$error = "";

if ((isset($_POST['keep']) || isset($_POST['upload_cover']) || isset($_POST['save_onlinecover']) || isset($_POST['save'])) && isset($_REQUEST['cover_id']) && IsNum($_REQUEST['cover_id'])) {
  $result = dbquery("SELECT * FROM `" . DB_STREAMSTATUS_COVERS . "` WHERE `ID` = '" . $_REQUEST['cover_id'] . "' LIMIT 1");
  $rows = dbrows($result);
  if ($rows == 0) {
    redirect(FUSION_SELF . $aidlink . '&section=covers');
    exit;
  } else {
    $current_data = dbarray($result);
  }
  // default cover?
  if (IsSet($_POST['save']) && IsSet($_POST['default_cover']) && $_POST['default_cover'] != "") {
    $result2 = dbquery("UPDATE `" . DB_STREAMSTATUS_COVERS . "` SET 
    `subfolder` = '__NO-COVER',
    `coverimage` = '" . stripinput($_POST['default_cover']) . "' 
    WHERE `ID` = '" . $_REQUEST['cover_id'] . "' LIMIT 1");
    if ($current_data['subfolder'] != "__NO-COVER") {
      if (file_exists((__DIR__ . "/../../covers/" . $current_data['subfolder'] . "/" . $current_data['coverimage']))) {
        @unlink(__DIR__ . "/../../covers/" . $current_data['subfolder'] . "/" . $current_data['coverimage']);
      }
      // check if folder ist empty, if yes > delete it
      $folder_files = dbcount('(`ID`)', DB_STREAMSTATUS_COVERS, "`subfolder` = '" . $current_data['subfolder'] . "';");
      if ($folder_files == 0 && file_exists(__DIR__ . "/../../covers/" . $current_data['subfolder'])) {
        @rmdir(__DIR__ . "/../../covers/" . $current_data['subfolder']);
      }
    }
  }
  if (IsSet($_POST['save_onlinecover']) && IsSet($_POST['cover_url']) && $_POST['cover_url'] != "") {
    $cover = file_get_contents(trim(stripinput($_POST['cover_url'])));
    if (empty($cover)) {
      // if nothing found, set default cover image
      $subfolder = "__NO-COVER";
      $imagefile = $default_cover;
    } else {
      // prepare imagefile name
      $search = array("Ä", "Ö", "Ü", "ä", "ö", "ü", "ß", "é", "è");
      $replace = array("Ae", "Oe", "Ue", "ae", "oe", "ue", "ss", "e", "e");
      $coverfile = explode(" - ", $current_data['songtitle']);
      if (count($coverfile) > 1) {
          $subfolder = preg_replace('/[^A-Za-z0-9ÄÖÜäöüß().\-]+/', '_', filter_filename(str_replace($search, $replace, trim($coverfile[0]))));
          $imagefile = preg_replace('/[^A-Za-z0-9ÄÖÜäöüß().\-]+/', '_', filter_filename(str_replace($search, $replace, trim($coverfile[1])))) . ".JPG";
      } else {
          $subfolder = "__NO-ARTIST";
          $imagefile = preg_replace('/[^A-Za-z0-9ÄÖÜäöüß().\-]+/', '_', filter_filename(str_replace($search, $replace, trim($coverfile[0])))) . ".JPG";
      }
      $subfolder = strtoupper($subfolder);
      $imagefile = strtoupper($imagefile);
      if (!file_exists(INFUSIONS . "streamstatus_panel/covers/" . $subfolder)) {
          mkdir(INFUSIONS . "streamstatus_panel/covers/" . $subfolder);
      }
      if (!empty($cover)) {
          @file_put_contents(INFUSIONS . "streamstatus_panel/covers/" . $subfolder . "/" . $imagefile, $cover);
      }
      $result = dbquery("UPDATE `" . DB_STREAMSTATUS_COVERS . "` SET 
      `coverimage` = '" . $imagefile . "',
      `subfolder` = '" . $subfolder . "',
      `lastupdate` = " . time() . "
      WHERE `ID` = " . $_REQUEST['cover_id'] . " LIMIT 1;");
    }
  }
  // Image uploaded?
  elseif (IsSet($_POST['upload_cover']) && IsSet($_FILES['cover_file']['name'])) {
    if (preg_match('@\.(GIF|PNG|JPG|JPEG|SVG)$@', strtoupper($_FILES['cover_file']['name']))) {
      $extension = strtoupper(substr(strrchr($_FILES['cover_file']['name'], "."), 1));
      // prepare imagefile name
      $search = array("Ä", "Ö", "Ü", "ä", "ö", "ü", "ß", "é", "è", "ñ");
      $replace = array("Ae", "Oe", "Ue", "ae", "oe", "ue", "ss", "e", "e", "n");
      $coverfile = explode(" - ", $current_data['songtitle']);
      if (count($coverfile) > 1) {
        $subfolder = preg_replace('/[^A-Za-z0-9ÄÖÜäöüß().\-]+/', '_', filter_filename(str_replace($search, $replace, trim($coverfile[0]))));
        $imagefile = preg_replace('/[^A-Za-z0-9ÄÖÜäöüß().\-]+/', '_', filter_filename(str_replace($search, $replace, trim($coverfile[1])))) . '.' . $extension;
      } else {
        $subfolder = "__NO-ARTIST";
        $imagefile = preg_replace('/[^A-Za-z0-9ÄÖÜäöüß().\-]+/', '_', filter_filename(str_replace($search, $replace, trim($coverfile[0])))) . '.' . $extension;
      }
      if (!file_exists(INFUSIONS . "streamstatus_panel/covers/" . $subfolder)) {
        @mkdir(INFUSIONS . "streamstatus_panel/covers/" . $subfolder);
      }
      if (!@move_uploaded_file($_FILES['cover_file']['tmp_name'], INFUSIONS . "streamstatus_panel/covers/" . $subfolder . "/" . $imagefile)) {
        $error .= "<li>" . $locale['SSP_242'] . "</li>\n";
      }
    } else {
      $error .= "<li>" . $locale['SSP_243'] . "</li>\n";
    }
    if (empty($error)) {
      // delete old file with different file extension
      if (strtoupper(substr(strrchr($current_data['coverimage'], "."), 1)) != $extension && $current_data['subfolder'] != "__NO-COVER" &&
      file_exists(INFUSIONS . "streamstatus_panel/covers/" . $subfolder . "/" .$current_data['coverimage'])) {
        @unlink(INFUSIONS . "streamstatus_panel/covers/" . $subfolder . "/" .$current_data['coverimage']);
      }
      $result = dbquery("UPDATE `" . DB_STREAMSTATUS_COVERS . "` SET `subfolder` = '" . $subfolder . "', `coverimage` = '" . $imagefile . "' WHERE `ID` = " . $current_data['ID'] . " LIMIT 1;");
    }
  }
  elseif (isset($_POST['keep'])) {
    // there is nothing to do here, save setting for permanent will follow
  }
  $permanent = (isset($_POST['set_permanent']) ? '1' : '0');
  if (empty($error)) {
    $result = dbquery("UPDATE `" . DB_STREAMSTATUS_COVERS . "` SET `permanent` = '" . $permanent . "', `lastupdate` = '" . time() . "' WHERE `ID` = " . $current_data['ID'] . " LIMIT 1;");
    redirect(FUSION_SELF . $aidlink . "&section=covers&action=edit&cover_id=" . $current_data['ID'] . "&status=success");
    exit;
  }
}

$arr_cookie_options = array(
  'expires' => time() + 3600, // valid for one hour
  'path' => '/',
  'domain' => '.' . $_SERVER['HTTP_HOST'],
  'secure' => true,
  'httponly' => true,
  'samesite' => 'Lax'
);

$switchform_js = '
<script>
  function switch_coverform(formname) {
    document.getElementById("deezer-form").style.display = "none";
    document.getElementById("upload-form").style.display = "none";
    document.getElementById("default-form").style.display = "none";
    document.getElementById("current-form").style.display = "none";
    document.getElementById(formname+"-form").style.display = "block";
  }
const buttons = document.querySelectorAll("input[type=\'radio\']");
buttons.forEach(button => {
  if (button.checked) {
    document.getElementById(button.value + "-form").style.display = "block";
  }
})
</script>
';

if (!isset($_GET['action']) || $_GET['action'] == 'filter') {
  add_to_footer('<script>
function list_covers() {
    let inputVal = document.getElementById("search_for").value;
    let qstring = "' . $aidlink . '&section=covers&action=filter";

    if (document.getElementById(\'no-cover\').checked) {
      qstring = qstring+"&nocover=1";
    }

    if (document.getElementById(\'permanent\').checked) {
      qstring = qstring+"&permanent=1";
    }

    var search_for = document.getElementById("search_for").value.trim();
    if (search_for != "") { qstring = qstring+"&search="+encodeURI(search_for); }
    
    CoverList("../ajax/search_covers.php"+qstring);
}

function CoverList(url) {
  let xmlHttp = false;
  try {
    xmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
  } catch (e) {
    try {
      xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
    } catch (e) {
      xmlHttp = false;
    }
  }
  if (!xmlHttp && typeof XMLHttpRequest != "undefined") {
    xmlHttp = new XMLHttpRequest();
  }

  if (xmlHttp) {
    xmlHttp.open("GET", url, true);
    xmlHttp.onreadystatechange = function () {
      if (xmlHttp.readyState == 4) {
        document.getElementById("coverlist").innerHTML = xmlHttp.responseText;
      }
    };
    xmlHttp.send(null);
  }
}
list_covers();
</script>
');

  echo '
<div class="ss-adminform">
    <div class="tbl-border">
        <div class="tbl-header">
           ' . $locale['SSP_244'] . '
        </div>
        <div class="tbl1" style="text-align: center;">
            <div>
              <input type="text" class="form-control textbox" style="width: 90%;" id="search_for" onkeyup="list_covers()" onpaste="list_covers()" placeholder="' . $locale['SSP_245'] . '"' . (!isset($_GET['clearfilter']) && isset($_COOKIE[COOKIE_PREFIX . 'adminform_search']) ? ' value="' . $_COOKIE[COOKIE_PREFIX . 'adminform_search'] . '"' : '') . ' />
            </div>
            <div>
              <label for="no-cover">' . $locale['SSP_246'] . '</label>
              <input type="checkbox" id="no-cover" onchange="list_covers()" />
            </div>
            <div>
              <label for="permanent">' . $locale['SSP_247'] . '</label>
              <input type="checkbox" id="permanent" onchange="list_covers()" />
            </div>
        </div>             
    </div>
</div>
<div id="coverlist"></div>
';
} elseif (isset($_GET['action']) && $_GET['action'] == 'edit' && isset($_GET['cover_id']) && IsNum($_GET['cover_id'])) {
  $result = dbquery("SELECT * FROM `" . DB_STREAMSTATUS_COVERS . "` WHERE `ID` = " . $_GET['cover_id'] . ";");
  $rows = dbrows($result);
  if ($rows == 0) {
    redirect(FUSION_SELF . $aidlink . '&section=covers');
    exit;
  } else {
    $cover = dbarray($result);
  }
  add_to_footer($switchform_js);
  add_to_footer('<script>
window.URL = window.URL || window.webkitURL;
 
function filePreview(files) {
  if(document.getElementById("cover_file").value != "") {
    var thumb = document.getElementById("preview"); 
    //thumb.innerHTML = ""; 
    if(!files)
      return; 
    for(var i = 0; i < files.length; i++) {
      var file = files[i]; 
      if(!file.type.match(/image.*/))
        continue; 
      let image = window.URL.createObjectURL(file);
      /*var img = document.createElement("img"); 
      img.src = window.URL.createObjectURL(file);
      img.style = "display: block; height: auto; width: 250px; margin: 0 auto;";
      img.id = "preview";
      img.onload = function(e) {
        window.URL.revokeObjectURL(this.src);
      }; 
      thumb.appendChild(img);*/
      document.getElementById("preview").src = image;
      console.log("Changed preview image to " + image);
    }
  }
  else {
    urlPreview("../images/upload-image.png");
  }
}

function urlPreview(url) {
  if (url != "") {
    let image = decodeURI(url);
    console.log("Change preview image to "+image);
    document.getElementById("preview").src = image;
  }
  else {
    document.getElementById("preview").src = "../images/search-online.png";
  }
}

function search_covers() {
    let qstring = "' . $aidlink . '";
    qstring = qstring+"&coverid=' . $cover['ID'] . '";
    var search_online = document.getElementById("search_online").value.trim();
    if (search_online != "") { qstring = qstring+"&song="+encodeURI(search_online); }
    console.log("GET ../ajax/search_onlinecovers.php"+qstring);
    CoverSearch("../ajax/search_onlinecovers.php"+qstring);
}

function CoverSearch(url) {
  document.getElementById("new_cover").innerHTML = "' . $locale['SSP_248'] . '";
  let xmlHttp = false;
  try {
    xmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
  } catch (e) {
    try {
      xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
    } catch (e) {
      xmlHttp = false;
    }
  }
  if (!xmlHttp && typeof XMLHttpRequest != "undefined") {
    xmlHttp = new XMLHttpRequest();
  }

  if (xmlHttp) {
    xmlHttp.open("GET", url, true);
    xmlHttp.onreadystatechange = function () {
      if (xmlHttp.readyState == 4) {

        coverurl = encodeURI(xmlHttp.responseText);
        if (coverurl != "") { 
			urlPreview(coverurl);
			document.getElementById("new_cover").innerHTML = "<input type=\"submit\" class=\"button btn btn-default\" value=\"' . $locale['SSP_240'] . '\" name=\"save_onlinecover\">";
			document.getElementById("cover_url").value = coverurl;
		}
		else {
			urlPreview("../images/search-online.png");
			document.getElementById("new_cover").innerHTML = "' . $locale['SSP_268'] . '";
		}
      }
    };
    xmlHttp.send(null);
  }
}
</script>');

  // Display errors or status
  if (!empty($error)) {
    echo "
      <div class='admin-error'>
        " . $locale['SSP_113'] . ":
        <ul>
            " . $error . "
        </ul>
      </div>\n";
  } elseif (isset($_GET['status']) && $_GET['status'] = "success") {
    echo "<div id='close-message'><div class='admin-success'>" . $locale['SSP_249'] . "</div></div>\n";
  }

  // define form elements for default cover
  $defaultcover_options = '';
  $cover_dir = openDir(INFUSIONS . "streamstatus_panel/covers/__NO-COVER/");
  while ($file = readDir($cover_dir)) {
    /* 
    All filenames including filename extensions may not contain lowercase letters !!!
    Wrong: Image1.jpg, IMAGE1.jpg, Image1.JPG
    Right: IMAGE1.JPG
    */
    if ((strstr($file, ".JPG") || strstr($file, ".PNG") || strstr($file, ".GIF") || strstr($file, ".SVG")) && $file == strtoupper($file)) {
      $defaultcover_options .= "<option value='" . $file . "'" . ((isset($_POST['default_cover']) && $_POST['default_cover'] == $file) || (!IsSet($_POST['default_cover']) && $file == $cover['coverimage']) ? " selected" : "") . ">" . $file . "</option>\n";
    }
  }

  echo '
<div class="ss-adminform">
    <div style="text-align: center; padding: 10pt;">[ <a href="' . FUSION_SELF . $aidlink . '&section=covers">&laquo; ' . $locale['SSP_214'] . '</a> ]</div>
    <div class="tbl-border">
        <div class="tbl-header">
            ' . $locale['SSP_250'] . '<br /><small>' . $cover['songtitle'] . '</small>
        </div>
        <div class="tbl">
          <form name="edit_cover" method="post" enctype="multipart/form-data">
            <input id="source" name="source" value="" style="display: none;" />
            <div id="cover_preview" style="text-align: center;">
              <img id="preview" style="display: block; height: auto; width: 250px; margin: 0 auto;" src="../covers/' . (!empty($cover['subfolder']) ? $cover['subfolder'] . '/' : '') . $cover['coverimage'] . '" />
            </div>
            <div class="tbl1" style="text-align: center;">
              <input type="checkbox" name="set_permanent"' . ((isset($_POST['set_permanent']) && $cover['permanent'] == '1') || !isset($_POST['set_permanent']) ? " checked" : "") . '>
              <label for="set_permanent">' . $locale['SSP_251'] . '</label><br />
              <div class="small">' . $locale['SSP_252'] . '</div>
            </div>
            <div style="text-align: center; margin: 10px;">
              <div class="tbl-header">' . $locale['SSP_253'] . '</div>
              <div class="tbl1" style="float: left; display: block; width: 23%; text-align: center;">
                <input type="radio" id="current" name="form-switch" value="current" onchange="switch_coverform(\'current\'); urlPreview(\'../covers/' . (!empty($cover['subfolder']) ? $cover['subfolder'] . '/' : '') . $cover['coverimage'] . '\');" checked><br>
                <label for="current"><span class="small">' . $locale['SSP_254'] . '</small></label>
              </div>
              <div class="tbl1" style="float: left; display: block; width: 23%; text-align: center;">
                <input type="radio" id="deezer" name="form-switch" value="deezer" onchange="switch_coverform(\'deezer\'); urlPreview(document.getElementById(\'cover_url\').value.trim())"><br>
                <label for="deezer"><span class="small">' . $locale['SSP_255'] . '</small></label>
              </div>
              <div class="tbl1" style="float: left; display: block; width: 23%; text-align: center;">
                <input type="radio" id="upload" name="form-switch" value="upload" onchange="switch_coverform(\'upload\'); filePreview(document.getElementById(\'cover_file\').files)"><br>
                <label for="upload"><span class="small">' . $locale['SSP_256'] . '</span></label>
              </div>
              <div class="tbl1" style="display: block; text-align: center;">
                <input type="radio" id="default" name="form-switch" value="default" onchange="switch_coverform(\'default\'); urlPreview(\'../covers/__NO-COVER/\'+document.getElementById(\'default_cover\').value.trim());"><br>
                <label for="default"><span class="small">' . $locale['SSP_257'] . '</span></label>
              </div>
            </div>
            <div id="current-form" class="tbl1" style="display: none; margin: 10px; text-align: center;">
              <input name="current_cover" type="hidden" value="../covers/' . (!empty($cover['subfolder']) ? $cover['subfolder'] . '/' : '') . $cover['coverimage'].'" />
              <input type="submit" name="keep" class="button btn btn-default btn-sm" value="' . $locale['SSP_240'] . '" />
            </div>
            <div id="deezer-form" class="tbl1" style="display: none; margin: 10px;">
              <input id="search_online" value="' . $cover['songtitle'] . '" class="textbox" style="width: calc(100% - 60px);" onkeydown="if(event.keyCode==13) { search_covers(); return false; }" />
              <input type="button" class="button btn-default btn-sm" name="searchnow" value="' . $locale['SSP_258'] . '" onclick="search_covers();" />
              <input id="cover_url" name="cover_url" type="hidden" value="" />
              <div id="new_cover" style="display: block; margin: 10px; height: 30px; text-align: center;"></div>
            </div>
            <div id="upload-form" class="tbl1" style="display: none; margin: 10px; text-align: center;">
              <input class="form-control textbox" type="file" name="cover_file" id="cover_file" style="max-width: 98%;" accept="image/*" onChange="filePreview(this.files);">
							<label class="form-input-label" for="cover_file">' . $locale['SSP_259'] . '</label>
              <br><br>
              <input type="submit" name="upload_cover" class="button btn btn-default btn-sm" value="' . $locale['SSP_241'] . '" />
            </div>
            <div id="default-form" class="tbl1" style="display: none; margin: 10px; text-align: center;">
              <select id="default_cover" name="default_cover" class="textbox" onChange="urlPreview(\'../covers/__NO-COVER/\' + this.value)">
                ' . $defaultcover_options . '
              </select>
              <input type="submit" name="save" class="button btn btn-default btn-sm" value="' . $locale['SSP_240'] . '" />
            </div>
          </form>
        </div>
    </div>
</div>
';
} elseif (isset($_GET['action']) && $_GET['action'] == 'delete' && isset($_GET['cover_id']) && IsNum($_GET['cover_id'])) {
  $result = dbquery("SELECT * FROM `" . DB_STREAMSTATUS_COVERS . "` WHERE `ID` = " . $_GET['cover_id'] . ";");
  $rows = dbrows($result);
  if ($rows == 0) {
    redirect(FUSION_SELF . $aidlink . '&section=covers');
    exit;
  } else {
    $cover = dbarray($result);
  }
  echo '
<div class="ss-adminform">
    <div style="text-align: center; padding: 10pt;">[ <a href="' . FUSION_SELF . $aidlink . '&section=covers">&laquo; ' . $locale['SSP_214'] . '</a> ]</div>
    <div class="tbl-border">
        <div class="tbl-header">
            ' . $locale['SSP_262'] . '
        </div>
        <div class="tbl1">
            ' . $locale['SSP_260'] . '
            <img style="display: block; height: auto; max-width: 100%; margin: 0 auto;" src="../covers/' . (!empty($cover['subfolder']) ? $cover['subfolder'] . '/' : '') . $cover['coverimage'] . '" />
            <div style="text-align: center; font-weight: bold;">' . $cover['songtitle'] . '</div>
            <div style="text-align: center; padding: 10px;">
            ' . ($cover['permanent'] == '1' ? $locale['SSP_261'] . '<br />' : '') . '<button class="btn-delcover" onclick="window.location.href=\'../administration/index.php' . $aidlink . '&section=covers&action=delconfirmed&cover_id=' . $cover['ID'] . '\'">' . $locale['SSP_262'] . '</button></div>                        
        </div>                                
    </div>
</div>
';
} elseif (isset($_GET['action']) && $_GET['action'] == 'delconfirmed' && isset($_GET['cover_id']) && IsNum($_GET['cover_id'])) {
  // löschen bestätigt, nun löschen:
  $result = dbquery("SELECT * FROM `" . DB_STREAMSTATUS_COVERS . "` WHERE `ID` = '" . $_REQUEST['cover_id'] . "' LIMIT 1");
  $rows = dbrows($result);
  if ($rows == 0) {
    redirect(FUSION_SELF . $aidlink . '&section=covers');
    exit;
  } else {
    $to_delete = dbarray($result);
  }
  $result = dbquery("DELETE FROM `" . DB_STREAMSTATUS_COVERS . "` WHERE `ID` = " . $_REQUEST['cover_id'] . " LIMIT 1;");
  if ($to_delete['subfolder'] != "__NO-COVER") {
    if (file_exists(__DIR__ . "/../../covers/" . $to_delete['subfolder'] . "/" . $to_delete['coverimage'])) {
      @unlink(__DIR__ . "/../../covers/" . $to_delete['subfolder'] . "/" . $to_delete['coverimage']);
    }
    // check if folder ist empty, if yes > delete it
    $folder_files = dbcount('(`ID`)', DB_STREAMSTATUS_COVERS, "`subfolder` = '" . $to_delete['subfolder'] . "';");
    if ($folder_files == 0 && file_exists(__DIR__ . "/../../covers/" . $to_delete['subfolder'])) {
      @rmdir(__DIR__ . "/../../covers/" . $to_delete['subfolder']);
    }
  }
  redirect(FUSION_SELF . $aidlink . "&section=covers&status=del_success&clearfilter=yes");
  exit;
}
