<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: settings.php
| Author: Andre Krell alias Krelli (systemweb.de & krelli.com)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) {
    die("Access Denied");
}

if (!checkrights("SWSS") || !defined("iAUTH") || $_GET['aid'] != iAUTH) {
    redirect(BASEDIR . "index.php");
}

if(defined('FUSION_V7')) {
	include(SWSS_LOCALE);
}
else {
	$locale = fusion_get_locale('', SWSS_LOCALE);
}

// update db if necessary
if (!IsSet($ssp_setting['listenerlist_visibility'])) {
	$result = dbquery("INSERT INTO`" . DB_STREAMSTATUS_SETTINGS . "` (`settings_name`, `settings_value`) VALUES ('listenerlist_visibility', 'siteadmin');");
	$ssp_setting['listenerlist_visibility'] = 'siteadmin';
}

echo "<div class='admintitle'>" . $locale['SSP_101'] . "</div>\n";

$error = "";

// save new settings
if (isset($_POST['savesettings']) && isset($_POST['panel_title']) && isset($_POST['listeners_visible']) && isset($_POST['delete_covers'])) {
    if ($_POST['panel_title'] != preg_replace('/[^A-Za-z0-9ÄÖÜäöüßèé@ :.,;\!\-]+/', '_', $_POST['panel_title'])) {
        $error .= "<li>" . $locale['SSP_113a'] . "</li>";
    } else {
        $panel_title = $_POST['panel_title'];
    }
    if (!IsNum($_POST['listeners_visible']) && $_POST['listeners_visible'] != 'guest' && $_POST['listeners_visible'] != 'member' && $_POST['listeners_visible'] != 'admin' && $_POST['listeners_visible'] != 'siteadmin' && $_POST['listeners_visible'] != 'nobody') {
        $error .= "<li>" . $locale['SSP_113b'] . "</li>";
    } else {
        $listeners_visibility = $_POST['listeners_visible'];
    }
	if (!IsNum($_POST['listenerlist_visible']) && $_POST['listenerlist_visible'] != 'admin' && $_POST['listenerlist_visible'] != 'siteadmin' && $_POST['listenerlist_visible'] != 'nobody') {
        $error .= "<li>" . $locale['SSP_113b'] . "</li>";
    } else {
        $listenerlist_visibility = $_POST['listenerlist_visible'];
    }
    if (!IsNum($_POST['delete_covers']) && $_POST['delete_covers'] != '0') {
        $error .= "<li>" . $locale['SSP_113c'] . "</li>";
    } else {
        $delete_covers = $_POST['delete_covers'];
    }
    $enable_covers = (isset($_POST['enable_covers']) ? '1' : '0');
    if ($enable_covers == '1' && !is_writable(INFUSIONS . "streamstatus_panel/covers")) {
        $error .= "<li>" . $locale['SSP_113d'] . "</li>";
    }
    
    $layout_compact = (isset($_POST['layout_compact']) && $_POST['layout_compact'] == '1' ? '1' : '0');
    $cover_size = (isset($_POST['cover_size']) ? $_POST['cover_size'] : '');
    if ($cover_size != 'big' && $cover_size != 'xl') {
        $cover_size = 'medium';
    }

    if (empty($error)) {
        $result = dbquery("UPDATE `" . DB_STREAMSTATUS_SETTINGS . "` SET `settings_value` = '" . $panel_title . "' WHERE `settings_name` = 'panel_title'");
        $result = dbquery("UPDATE `" . DB_STREAMSTATUS_SETTINGS . "` SET `settings_value` = '" . $listeners_visibility . "' WHERE `settings_name` = 'listeners_visibility'");
        $result = dbquery("UPDATE `" . DB_STREAMSTATUS_SETTINGS . "` SET `settings_value` = '" . $enable_covers . "' WHERE `settings_name` = 'enable_covers'");
        $result = dbquery("UPDATE `" . DB_STREAMSTATUS_SETTINGS . "` SET `settings_value` = '" . $delete_covers . "' WHERE `settings_name` = 'delete_covers'");
        $result = dbquery("UPDATE `" . DB_STREAMSTATUS_SETTINGS . "` SET `settings_value` = '" . $layout_compact . "' WHERE `settings_name` = 'layout_compact'");
        $result = dbquery("UPDATE `" . DB_STREAMSTATUS_SETTINGS . "` SET `settings_value` = '" . $cover_size . "' WHERE `settings_name` = 'cover_size'");
		$result = dbquery("UPDATE `" . DB_STREAMSTATUS_SETTINGS . "` SET `settings_value` = '" . $listenerlist_visibility . "' WHERE `settings_name` = 'listenerlist_visibility'");
        redirect(FUSION_SELF . $aidlink . "&page=settings&status=success");
    }
}
// load group ids in array
$listeners_visibility_groups_options = "";
$listenerlist_visibility_groups_options = "";
$result = dbquery("SELECT `group_id`, `group_name` FROM `" . DB_USER_GROUPS . "` ORDER BY `group_name` ASC;");
$rows = dbrows($result);
if ($rows > 0) {
    while ($g_data = dbarray($result)) {
        $listeners_visibility_groups_options .= "<option value='" . $g_data['group_id'] . "'" . ((isset($_POST['listeners_visible']) && $_POST['listeners_visible'] == $g_data['group_id']) || (!isset($_POST['listeners_visible']) && $ssp_setting['listeners_visibility'] == $g_data['group_id']) ? " selected='selected'" : "") . ">" . $locale['SSP_105c'] . ": " . $g_data['group_name'] . "</option>
        ";
		$listenerlist_visibility_groups_options .= "<option value='" . $g_data['group_id'] . "'" . ((isset($_POST['listenerlist_visible']) && $_POST['listenerlist_visible'] == $g_data['group_id']) || (!isset($_POST['listenerlist_visible']) && $ssp_setting['listenerlist_visibility'] == $g_data['group_id']) ? " selected='selected'" : "") . ">" . $locale['SSP_105c'] . ": " . $g_data['group_name'] . "</option>
        ";
    }
}

// Display errors or status
if (!empty($error)) {
    echo "
    <div class='admin-error'>
        " . $locale['SSP_113'] . ":
        <ul>
            " . $error . "
        </ul>
    </div>\n";
} elseif (isset($_GET['status']) && $_GET['status'] = "success") {
    echo "<div id='close-message'><div class='admin-success'>" . $locale['SSP_114'] . "</div></div>\n";
}

// settings form
echo "<form name='settingsform' method='post' action='" . FUSION_SELF . $aidlink . "&section=settings'>\n";
echo "<table class='tbl-border center' style='max-width: 100%; margin:0 auto; padding: 0; border: 0;'>\n<tr>\n";
echo "<td class='tbl1'>" . $locale['SSP_104'] . "</td><td class='tbl1'><input type='text' name='panel_title' class='textbox' value='" . (isset($_POST['panel_title']) ? $_POST['panel_title'] : $ssp_setting['panel_title']) . "' maxlength='40'></td>\n";
echo "</tr>\n<tr>\n";
echo "<td class='tbl2'>" . $locale['SSP_105'] . "</td><td class='tbl2'>
    <select name='listeners_visible' class='textbox'>
        <option value='guest'" . ((isset($_POST['listeners_visible']) && $_POST['listeners_visible'] == 'guest') || (!isset($_POST['listeners_visible']) && $ssp_setting['listeners_visibility'] == 'guest') ? " selected='selected'" : "") . ">" . $locale['SSP_105a'] . "</option>
        <option value='member'" . ((isset($_POST['listeners_visible']) && $_POST['listeners_visible'] == 'member') || (!isset($_POST['listeners_visible']) && $ssp_setting['listeners_visibility'] == 'member') ? " selected='selected'" : "") . ">" . $locale['SSP_105b'] . "</option>
        " . $listeners_visibility_groups_options . "
        <option value='admin'" . ((isset($_POST['listeners_visible']) && $_POST['listeners_visible'] == 'admin') || (!isset($_POST['listeners_visible']) && $ssp_setting['listeners_visibility'] == 'admin') ? " selected='selected'" : "") . ">" . $locale['SSP_105d'] . "</option>
        <option value='siteadmin'" . ((isset($_POST['listeners_visible']) && $_POST['listeners_visible'] == 'siteadmin') || (!isset($_POST['listeners_visible']) && $ssp_setting['listeners_visibility'] == 'siteadmin') ? " selected='selected'" : "") . ">" . $locale['SSP_105e'] . "</option>
        <option value='nobody'" . ((isset($_POST['listeners_visible']) && $_POST['listeners_visible'] == 'nobody') || (!isset($_POST['listeners_visible']) && $ssp_setting['listeners_visibility'] == 'nobody') ? " selected='selected'" : "") . ">" . $locale['SSP_105f'] . "</option>
    </select>
    </td>\n";
echo "</tr>\n<tr>\n";
echo "<td class='tbl1'>" . $locale['SSP_105z'] . "</td><td class='tbl1'>
    <select name='listenerlist_visible' class='textbox'>
        " . $listenerlist_visibility_groups_options . "
        <option value='admin'" . ((isset($_POST['listenerlist_visible']) && $_POST['listenerlist_visible'] == 'admin') || (!isset($_POST['listenerlist_visible']) && $ssp_setting['listenerlist_visibility'] == 'admin') ? " selected='selected'" : "") . ">" . $locale['SSP_105d'] . "</option>
        <option value='siteadmin'" . ((isset($_POST['listenerlist_visible']) && $_POST['listenerlist_visible'] == 'siteadmin') || (!isset($_POST['listenerlist_visible']) && $ssp_setting['listenerlist_visibility'] == 'siteadmin') ? " selected='selected'" : "") . ">" . $locale['SSP_105e'] . "</option>
        <option value='nobody'" . ((isset($_POST['listenerlist_visible']) && $_POST['listenerlist_visible'] == 'nobody') || (!isset($_POST['listenerlist_visible']) && $ssp_setting['listenerlist_visibility'] == 'nobody') ? " selected='selected'" : "") . ">" . $locale['SSP_105f'] . "</option>
    </select>
    </td>\n";
echo "</tr>\n<tr>\n";
echo "<td class='tbl2'>" . $locale['SSP_106'] . "</td><td class='tbl2'><input type='checkbox' name='enable_covers'" . ((isset($_POST['enable_covers']) && $_POST['enable_covers'] == '1') || (!isset($_POST['enable_covers']) && $ssp_setting['enable_covers'] == '1') ? " checked" : "") . "></td>\n";
echo "</tr>\n<tr>\n";
echo "<td class='tbl1'>" . $locale['SSP_109'] . "</td><td class='tbl1'>
    <select name='cover_size' class='textbox'>
        <option value='medium'" . ((isset($_POST['cover_size']) && $_POST['cover_size'] == 'medium') || (!isset($_POST['cover_size']) && $ssp_setting['cover_size'] == 'medium') ? " selected='selected'" : "") . ">" . $locale['SSP_109a'] . "</option>
        <option value='big'" . ((isset($_POST['cover_size']) && $_POST['cover_size'] == 'big') || (!isset($_POST['cover_size']) && $ssp_setting['cover_size'] == 'big') ? " selected='selected'" : "") . ">" . $locale['SSP_109b'] . "</option>
        <option value='xl'" . ((isset($_POST['cover_size']) && $_POST['cover_size'] == 'xl') || (!isset($_POST['cover_size']) && $ssp_setting['cover_size'] == 'xl') ? " selected='selected'" : "") . ">" . $locale['SSP_109c'] . "</option>
        </select>
</td>\n";
echo "</tr>\n<tr>\n";
echo "<td class='tbl2'>" . $locale['SSP_107'] . "</td><td class='tbl2'>
    <select name='delete_covers' class='textbox'>
        <option value='86400'" . ((isset($_POST['delete_covers']) && $_POST['delete_covers'] == '86400') || (!isset($_POST['delete_covers']) && $ssp_setting['delete_covers'] == '86400') ? " selected='selected'" : "") . ">" . $locale['SSP_107a'] . "</option>
        <option value='259200'" . ((isset($_POST['delete_covers']) && $_POST['delete_covers'] == '259200') || (!isset($_POST['delete_covers']) && $ssp_setting['delete_covers'] == '259200') ? " selected='selected'" : "") . ">" . $locale['SSP_107b'] . "</option>
        <option value='604800'" . ((isset($_POST['delete_covers']) && $_POST['delete_covers'] == '604800') || (!isset($_POST['delete_covers']) && $ssp_setting['delete_covers'] == '604800') ? " selected='selected'" : "") . ">" . $locale['SSP_107c'] . "</option>
        <option value='2592000'" . ((isset($_POST['delete_covers']) && $_POST['delete_covers'] == '2592000') || (!isset($_POST['delete_covers']) && $ssp_setting['delete_covers'] == '2592000') ? " selected='selected'" : "") . ">" . $locale['SSP_107d'] . "</option>
        <option value='7776000'" . ((isset($_POST['delete_covers']) && $_POST['delete_covers'] == '7776000') || (!isset($_POST['delete_covers']) && $ssp_setting['delete_covers'] == '7776000') ? " selected='selected'" : "") . ">" . $locale['SSP_107e'] . "</option>
        <option value='15552000'" . ((isset($_POST['delete_covers']) && $_POST['delete_covers'] == '15552000') || (!isset($_POST['delete_covers']) && $ssp_setting['delete_covers'] == '15552000') ? " selected='selected'" : "") . ">" . $locale['SSP_107f'] . "</option>
        <option value='31104000'" . ((isset($_POST['delete_covers']) && $_POST['delete_covers'] == '31104000') || (!isset($_POST['delete_covers']) && $ssp_setting['delete_covers'] == '31104000') ? " selected='selected'" : "") . ">" . $locale['SSP_107g'] . "</option>
        <option value='0'" . ((isset($_POST['delete_covers']) && $_POST['delete_covers'] == '0') || (!isset($_POST['delete_covers']) && $ssp_setting['delete_covers'] == '0') ? " selected='selected'" : "") . ">" . $locale['SSP_107h'] . "</option>
        </select>
</td>\n";
echo "</tr>\n<tr>\n";
echo "<td class='tbl1' colspan='2'>" . $locale['SSP_108'] . "<sup>*</sup><br />
    <input type='radio' id='layout_compact_1' name='layout_compact' value='1'" .                                ((!isset($_POST['layout_compact']) && $ssp_setting['layout_compact'] != '0') || (isset($_POST['layout_compact']) && $_POST['layout_compact'] != '0') ? ' checked="checked"' : '') . ">
    <label for='layout_compact_1'>" . $locale['SSP_108a'] . "</label><br>
    <input type='radio' id='layout_compact_0' name='layout_compact' value='0'" .                                ((!isset($_POST['layout_compact']) && $ssp_setting['layout_compact'] == '0') || (isset($_POST['layout_compact']) && $_POST['layout_compact'] == '0') ? ' checked="checked"' : '') . ">
    <label for='layout_compact_0'>" . $locale['SSP_108b'] . "</label><br /><br />
    <span class='small'><sup>*</sup>" . $locale['SSP_108c'] . "</span>
</td>\n";
echo "</tr>\n</table>\n";
echo "<div style='text-align: center; padding: 15px;'><input type='submit' name='savesettings' value='" . $locale['SSP_110'] . "' class='button' /></div>\n";
echo "</form>\n";

echo "<div class='infobox'>
    <span class='title'>" . $locale['SSP_111'] . ":</span>
    <p>" . $locale['SSP_112'] . "</p>
</div>\n";
