<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: fetch_listeners.php
| Author: Andre Krell (systemweb.de & krelli.com)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
header("Expires: Sat, 05 Nov 2005 00:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

require_once(__DIR__ . "/../../../maincore.php");
require_once(__DIR__ . "/../infusion_db.php");
require_once(__DIR__ . "/../includes/ss_functions.php");

$streamstatus_installed = FALSE;

$result = dbquery("SHOW TABLES LIKE '" . DB_STREAMSTATUS_STREAMS . "'");
if (dbrows($result) != 0) {
	// Ok, streamstatus is infused. Now check if there is at least 1 stream defined.
	if (dbcount('(`ID`)', DB_STREAMSTATUS_STREAMS) > 0) {
		$streamstatus_installed = TRUE;
	}
}

if ($streamstatus_installed) {
	$result = dbquery("SELECT * FROM " . DB_STREAMSTATUS_SETTINGS);
	if (dbrows($result)) {
		while ($data = dbarray($result)) {
			$ssp_setting[$data['settings_name']] = $data['settings_value'];
		}
	}

	if(defined('FUSION_V7')) {
		include(SWSS_LOCALE);
	}
	else {
		$locale = fusion_get_locale('', SWSS_LOCALE);
	}
	
	if(!IsSet($ssp_setting['listenerlist_visibility'])) { $ssp_setting['listenerlist_visibility'] = 'siteadmin'; }
	$viewlistenerlist = $ssp_setting['listenerlist_visibility'];
	
	// check access rights
	if ($viewlistenerlist != '0' && (iSUPERADMIN || ($viewlistenerlist == 'admin' && iADMIN) || (IsNum($viewlistenerlist) && checkgroup($viewlistenerlist)))) {

		$streamstatus_installed = FALSE;

		$result = dbquery("SHOW TABLES LIKE '" . DB_STREAMSTATUS_STREAMS . "'");
		if (dbrows($result) != 0) {
			// Ok, streamstatus is infused. Now check if there is at least 1 stream defined.
			if (dbcount('(`ID`)', DB_STREAMSTATUS_STREAMS) > 0) {
				$streamstatus_installed = TRUE;
			}
		}

		// stop if not installed
		if (!$streamstatus_installed) {
			die(); 
		}

		// get channels
		$result = dbquery("SELECT * FROM " . DB_STREAMSTATUS_STREAMS);
		if (dbrows($result)) {
			while ($s_data = dbarray($result)) {
				$listeners = false;
				$xml = false;
				if($s_data['stream_type'] == "shoutcast1" OR $s_data['stream_type'] == "shoutcast2") {
					echo "<h3 style='text-align: center; margin: 5px;'>".$s_data['stream_title']."</h3>\n";
					// Shoutcast XML
					$url = "http://" . gethostbyname($s_data['stream_server']) . ":" . $s_data['stream_port'] . "/";
					$ch = curl_init();
					curl_setopt($ch, CURLOPT_URL, $url . "admin.cgi?sid=" . $s_data['stream_id'] . "&mode=viewxml");
					curl_setopt($ch, CURLOPT_HEADER, FALSE);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
					curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0");
					curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
					curl_setopt($ch, CURLOPT_TIMEOUT, 10);
					curl_setopt($ch, CURLOPT_IPRESOLVE, CURL_IPRESOLVE_V4);
					curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
					curl_setopt($ch, CURLOPT_SSL_VERIFYSTATUS, FALSE);
					$encodedAuth = base64_encode("admin:" . $s_data['stream_adminpw']);
					curl_setopt($ch, CURLOPT_HTTPHEADER, array("Authorization: Basic ".$encodedAuth));

					$xml = curl_exec($ch);
					$httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
					if ($httpcode >= 200 && $httpcode < 300) {
						$listeners = new SimpleXMLElement($xml);
						if ($listeners->STREAMSTATUS == '1') {
							echo "<div class='small' style='text-align: center; padding: 3px;'>" . $listeners->CURRENTLISTENERS . " " . $locale['SSP_302'] . "</div>\n";
							// stream is online, proceed
							echo "<table class='tbl-border' style='margin: 0 auto; max-width: 100%;border: 1px solid #900;'>\n";
							echo "<thead><th class='tbl-header' style='padding: 5px;'>" . $locale['SSP_309'] . "</th><th class='tbl-header' style='padding: 5px;'>" . $locale['SSP_303'] . "</th><th class='tbl-header' style='padding: 5px;'>" . $locale['SSP_304'] . "</th></thead>\n";
							$listeners_count = 0;
							$i = 0;
							foreach ($listeners->LISTENERS->LISTENER as $listener) {
								$listeners_count++;
								$search_ip = $listener->HOSTNAME;
								if ($search_ip == "127.0.0.1" && $listener->XFF != "") { $search_ip = $listener->XFF; }
								$result2 = dbquery("SELECT user_id, user_name FROM " . DB_USERS . " WHERE user_ip = '" . $search_ip . "' LIMIT 1;");
								if (dbrows($result2)) {
									// show know members
									$tmp = dbarray($result2);
									$i++;
									if (is_integer($i/2)) $tblclass="class='tbl2'";
									else $tblclass="class='tbl1'";
									echo "<tr><td $tblclass style='padding: 5px; text-align: left;'><a href='" . $settings['siteurl'] . "profile.php?lookup=" . $tmp['user_id'] . "' title='Profil'>". $tmp['user_name'] . "</a></td><td $tblclass style='padding: 5px;'>" . $search_ip . "</td><td $tblclass style='padding: 5px;'>" . intval($listener->CONNECTTIME / 60). " " . (intval($listener->CONNECTTIME / 60) == 1 ? $locale['SSP_305'] : $locale['SSP_306']) . "</td></tr>\n";
								}
								else {
									// show guests / unknown
									$i++;
									if (is_integer($i/2)) $tblclass="class='tbl2'";
									else $tblclass="class='tbl1'";
									echo "<tr><td $tblclass style='padding: 3px;'>" . $locale['SSP_307'] . "</td><td $tblclass style='padding: 3px;'>" . $search_ip . "</td><td $tblclass style='padding: 3px;'>" . intval($listener->CONNECTTIME / 60). " " . (intval($listener->CONNECTTIME / 60) == 1 ? $locale['SSP_305'] : $locale['SSP_306']) . "</td></tr>\n";
								}
							}
							if ($listeners_count == 0) {
								echo "<tr><td colspan='4' style='text-align: center; padding: 3px;'><small>" . $locale['SSP_308'] . "</small></td></tr>\n";
							}
							echo "</table>\n<br>";
						}
						else {
							echo "<div class='text-center'>" . $locale['SSP_310'] . "</div>\n";
						}
						curl_close($ch);
					}
					else echo "<div class='text-center'>" . $locale['SSP_311'] . "</div>\n";
				}
			}
		}
	}
	else {
		die($locale['SSP_301']);
	}
}

