<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: fetch_streamdata.php
| Author: Andre Krell (systemweb.de & krelli.com)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
header("Expires: Sat, 05 Nov 2005 00:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

require_once(__DIR__ . "/../../../maincore.php");
require_once(__DIR__ . "/../infusion_db.php");
require_once(__DIR__ . "/../includes/ss_functions.php");

if (!isset($_GET['id']) || !IsNum($_GET['id'])) {
	die();
}

$streamstatus_installed = FALSE;

$result = dbquery("SHOW TABLES LIKE '" . DB_STREAMSTATUS_STREAMS . "'");
if (dbrows($result) != 0) {
	// Ok, streamstatus is infused. Now check if there is at least 1 stream defined.
	if (dbcount('(`ID`)', DB_STREAMSTATUS_STREAMS) > 0) {
		$streamstatus_installed = TRUE;
	}
}

// stop if not installed
if (!$streamstatus_installed) {
    die(); 
}

$result = dbquery("SELECT * FROM " . DB_STREAMSTATUS_STREAMS . " WHERE `ID` = " . intval($_GET['id']));
if (dbrows($result) == 0) {
    // stop if ID not found
	die();
}
else {
    $s_data = dbarray($result);
}

// limit data fetches to save webserver ressources (in seconds)
if((time() - $s_data['stream_lastrequest']) < 15) { // only one random visitor initiates request
    die();
}

// generate new timestamp at beginning to prevent multiple updates from different users same time
// we add more seconds for slow connections to complete this request and update it at the end of this script
$result = dbquery("UPDATE `" . DB_STREAMSTATUS_STREAMS . "` SET `stream_lastrequest`= " . (time()+30) . " WHERE `ID` = " . $_GET['id'] . " LIMIT 1");

// Load settings
$result = dbquery("SELECT * FROM " . DB_STREAMSTATUS_SETTINGS);
if (dbrows($result)) {
	while ($data = dbarray($result)) {
		$ssp_setting[$data['settings_name']] = $data['settings_value'];
	}
}

if($s_data['stream_scheduler'] == "transcoder") {
	// pruefen ob Server und Port erreichbar
	if(onlinecheck($s_data['stream_tc_server'],$s_data['stream_tc_adminport'])) {	
	    $post_data = array(
		    'op' => 'getstatus',
		    'seq' => '45'
	    );
        // API Zugriff
	    $api_request = sc_trans_request($s_data['stream_tc_server'], $s_data['stream_tc_adminport'], $s_data['stream_tc_adminuser'], $s_data['stream_tc_adminpass'], $post_data);
	    if ($api_request['status'] == 'ok') {
		    preg_match("/<name>(.*)<\/name>/Uis", $api_request['content'], $active_name);
		    if (IsSet($active_name[1]) && $active_name[1] != 'Playlist') { 
				$result2 = dbquery("SELECT `user_id` FROM `" . DB_USERS . "` WHERE `user_name` = '" . stripinput($active_name[1]) . "' LIMIT 1");
				if (dbrows($result2) != 0) {
					$u_data = dbarray($result2);
					$current_dj_id = $u_data['user_id'];
				}
            }
	    }
    }
}
elseif($s_data['stream_scheduler'] == "aim") {
	// Shoutcast XML
	$url = ($s_data['stream_ssl'] == '1' ? "https://" : "http://") . $s_data['stream_server'] . ":" . $s_data['stream_port'] . "/";
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url . "admin.cgi?mode=viewxml");
	curl_setopt($ch, CURLOPT_HEADER, FALSE);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0");
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
	curl_setopt($ch, CURLOPT_TIMEOUT, 10);
	curl_setopt($ch, CURLOPT_IPRESOLVE, CURL_IPRESOLVE_V4);
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
	curl_setopt($ch, CURLOPT_SSL_VERIFYSTATUS, FALSE);
	curl_setopt($ch, CURLOPT_USERPWD, "admin:" . $s_data['stream_adminpw']);
	$xml = curl_exec($ch);
	$httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
	if ($httpcode >= 200 && $httpcode < 300) {
		preg_match("~<STREAMSTATUS>(.*?)<\/STREAMSTATUS>~is", $xml, $match);
		if (IsSet($match[1]) && $match[1] == '1') {
			// stream is online, proceed
			preg_match("~<AIM>(.*?)</AIM>~", $xml, $djname);
			if (IsSet($djname[1]) && $djname[1] != "" && $djname[1] != "NA") {
				// AIM is customized, proceed
				$result = dbquery("SELECT `user_id` FROM `" . DB_USERS . "` WHERE `user_name` = '" . stripinput($djname[1]) . "' LIMIT 1");
				$rows = dbrows($result);
				if ($rows != 0) {
					$found = dbarray($result);
					$current_dj_id = $found['user_id'];
				}
			}
		}
	}
}
elseif($s_data['stream_scheduler'] == "azuracast") {
	$api_url = $s_data['stream_ac_server'];
	$api_key = $s_data['stream_ac_apikey'];
	$api_channel_id = $s_data['stream_ac_channel'];
	$ch = curl_init($api_url.'/api/nowplaying/'.$api_channel_id);
	curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json' , 'X-API-KEY: '.$api_key ));
	curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/4.0 (compatible;)');
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
	curl_setopt($ch, CURLOPT_TIMEOUT, 10);
	curl_setopt($ch, CURLOPT_IPRESOLVE, CURL_IPRESOLVE_V4);
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
	curl_setopt($ch, CURLOPT_SSL_VERIFYSTATUS, FALSE);
	$data = curl_exec($ch);
	if(!curl_errno($ch)) {
		$info = curl_getinfo($ch);
		$output = ob_get_contents();
		curl_close($ch);
		ob_end_clean();
		$tmp = json_decode($output, true);
		if ($tmp['live']['is_live'] == true && $tmp['live']['streamer_name'] != "") {
			$search_dj = $tmp['live']['streamer_name'];
			$result = dbquery("SELECT `user_id` FROM `" . DB_USERS . "` WHERE `user_name` = '" . $search_dj . "' LIMIT 1;");
			$rows = dbrows($result);
			if ($rows == 0) {
				$current_dj_id = "0";
			} else {
				$udata = dbarray($result);
				$current_dj_id = $udata['user_id'];
			}
		}
	}
	else {
		ob_end_clean();
		echo curl_error($ch);
		$current_dj_id = "0";
	}
}

$result = dbquery("SELECT * FROM `" . DB_STREAMSTATUS_STREAMS . "` WHERE `ID` = '" . intval($_GET['id']) . "' LIMIT 1");
$rows = dbrows($result);
if ($rows == 0) {
	die();
} else {
	$data = dbarray($result);
	$protocol = ($data['stream_ssl'] == "1" ? "https" : "http");
	$server = $data['stream_server'];
	$port = $data['stream_port'];
	$type = $data['stream_type'];
	if ($data['stream_type'] == 'icecast' || $data['stream_type'] == 'stream24') {
		$mountpoint = $data['stream_mountpoint'];
	} elseif ($data['stream_type'] == 'shoutcast2') {
		$mountpoint = $data['stream_id'];
	} elseif ($data['stream_type'] == 'lautfm') {
		$mountpoint = $data['stream_channelname'];
	} else {
		$mountpoint = false;
	}
	$current_song = getSongInfo($protocol, $type, $server, $port, $mountpoint);
	$current_listeners = getListeners($protocol,$type,$server,$port,$mountpoint);

	if (!$current_song) {
		$current_song = 'offline';
	}
	// check if online dj info is given in songtitle
	if ($data['stream_scheduler'] == 'songtitle' && $data['stream_songspacer'] != "") {
		$tmp = trim(explode($data['stream_songspacer'], $current_song));
		if (IsSet($tmp[1]) && $tmp[1] != "") {
			$result2 = dbquery("SELECT `user_id` FROM `" . DB_USERS . "` WHERE `user_name` = '" . stripinput($tmp[1]) . "' LIMIT 1");
			$rows = dbrows($result2);
			if ($rows != 0) {
				$data2 = dbarray($result2);
				$current_dj_id = $data2['user_id'];
				$current_song = trim($tmp[0]);
			}
		}
	}
	if (!$current_listeners) {
		$current_listeners = '0';
	}
}

// save to DB
$result = dbquery("UPDATE `" . DB_STREAMSTATUS_STREAMS . "` SET 
`stream_currentdj` = '" . (IsSet($current_dj_id) && IsNum($current_dj_id) ? $current_dj_id : "0") . "',
`stream_currentsong` = '" . (IsSet($current_song) && $current_song !="" ? addslashes($current_song) : "") . "',
`stream_currentlisteners` = '" . (IsSet($current_listeners) && IsNum($current_listeners) ? $current_listeners : "0") . "'
WHERE `ID` = " . intval($_GET['id']) . " LIMIT 1");

// update cover if enabled, layout is not only one cover  
if ($ssp_setting['enable_covers'] == '1') {
    $result = dbquery("SELECT `ID` FROM " . DB_STREAMSTATUS_STREAMS . " WHERE `ID` < " . intval($_GET['id']));
	if (dbrows($result) == 0 || $ssp_setting['layout_compact'] == '0') {
        $coverimg = getCoverImage($_GET['id']);
    }
    else {
        $coverimg = "Not needed in compact layout.";
    }
}
else {
	$coverimg = "Cover-Feature not enabled";
}

// generate new timestamp after finishing the whole requests (it may have taken some seconds)
$result = dbquery("UPDATE `" . DB_STREAMSTATUS_STREAMS . "` SET `stream_lastrequest`= " . time() . " WHERE `ID` = " . $_GET['id'] . " LIMIT 1");

$deleted = delete_covers(25); // delete covers (intervall amount), which are not permanent and reached time limit for keeping it saved

// following output is for debugging
echo "STREAMER-ID: " . (IsSet($current_dj_id) && IsNum($current_dj_id) ? $current_dj_id : "0 (no live event or dj-name not found in fusion_users table)");
echo "<br><br>SONG: " . addslashes($current_song);
echo "<br><br>LISTENERS: " . intval($current_listeners);
echo "<br><br>COVER: " . $coverimg;
echo "<br><br>AUTO-DELETED COVERS: " . $deleted;
