<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: search_covers.php
| Author: Andre Krell (systemweb.de & krelli.com)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require(__DIR__ . "/../../../maincore.php");
require(__DIR__ . "/../infusion_db.php");

if (!checkrights("SWSS") || !defined("iAUTH") || $_GET['aid'] != iAUTH) {
    die("Access denied.");
}

if(defined('FUSION_V7')) {
	include(SWSS_LOCALE);
}
else {
	$locale = fusion_get_locale('', SWSS_LOCALE);
}

$arr_cookie_options = array(
    'expires' => time() + 3600, // valid for one hour
    'path' => '/',
    'domain' => '.' . $_SERVER['HTTP_HOST'],
    'secure' => true,
    'httponly' => true,
    'samesite' => 'Lax'
);

if (isset($_GET['clearfilter']) && $_GET['clearfilter'] == "yes") {
    setcookie(COOKIE_PREFIX . 'adminform_search', '', $arr_cookie_options);
}

if (isset($_GET['action']) && $_GET['action'] == "filter") {
    $sql_filter = "";
    if (isset($_GET['nocover']) && $_GET['nocover'] == 1) {
        $sql_filter .= "`subfolder` = '__NO-COVER'";
    }
    if (isset($_GET['permanent']) && $_GET['permanent'] == 1) {
        $sql_filter .= (!empty($sql_filter) ? 'AND ' : '') . "`permanent` = '1'";
    }
    // search keywords
    if (isset($_GET['search']) && $_GET['search'] != "") {
        $data_fields = array("songtitle");
        $search = trim(preg_replace('/\s+/', ' ', cleanurl(urldecode($_GET['search']))));
        $search_pre = "";
        setcookie(COOKIE_PREFIX . "adminform_search", $search, $arr_cookie_options);

        if ($search != "") {          
            if ($sql_filter != "") {
                $search_pre = " AND (";
            }
            $words = explode(" ", $search);
            $searchstr = "";
            for ($i = 0; $i < count($words); $i++) {
                foreach ($data_fields as $datafield) {
                    if ($searchstr != "") {
                        $searchstr .= "AND ";
                    }
                    $searchstr .= "`" . $datafield . "` LIKE '%" . $words[$i] . "%' ";
                }
            }
            $sql_filter .= $search_pre . $searchstr . ($search_pre != "" ? ")" : "");
        }
    } else {
        setcookie(COOKIE_PREFIX . 'adminform_search', '', $arr_cookie_options);
    }
    if (!isset($_REQUEST['limit']) || !IsNum($_REQUEST['limit']) || $_REQUEST['limit'] > 100 || $_REQUEST['limit'] < 1) {
        $limit = " LIMIT 10";
    } else {
        $limit = " LIMIT " . $_REQUEST['limit'];
    }
    $sql_q = "SELECT * FROM `" . DB_PREFIX . "streamstatus_covers`" . ($sql_filter != "" ? " WHERE " . $sql_filter : "") . " ORDER BY `songtitle` ASC " . $limit;
    $result = dbquery($sql_q);
    $rows = dbrows($result);
    if ($rows != 0) {
        echo "<br />\n<div class='tbl-border' style='display: block; width: 100%; text-align: center; margin: 10px;'><div class='tbl1'>" . $locale['SSP_263'] . "</div></div>\n";
        while ($data = dbarray($result)) {
            echo '<div class="tbl-border cover-box">
                <div class="tbl2" style="border-radius: 5px 5px 0 0;">
                    <div style="display: block;">
                        <img style="display: block;" src="../covers/' . (!empty($data['subfolder']) ? $data['subfolder'] . '/' : '') . $data['coverimage'] . '" width="100%" />
                    </div>
                    <div style="display: block; text-align: center;">
                        <button class="btn-delcover" onclick="window.location.href=\'../administration/index.php' . $aidlink . '&section=covers&action=delete&cover_id=' . $data['ID'] . '\';">' . $locale['SSP_266'] . '</button>
                        <button class="btn-editcover" onclick="window.location.href=\'../administration/index.php' . $aidlink . '&section=covers&action=edit&cover_id=' . $data['ID'] . '\';">' . $locale['SSP_267'] . '</button>
                    </div>
                </div>
                <div class="tbl1" style="height: 30pt; border-radius: 0 0 5px 5px; font-weight: bold; font-size: 11px;">
                    ';
            // mark search hits in different color:
            $songtitle = $data['songtitle'];
            if(IsSet($search) && $search != "") {
                $search_hits = explode(" ", $search);
                foreach ($search_hits as $hit) {
                    $songtitle = str_replace(strtoupper($hit), '<span class="searchtext-marker">' . strtoupper($hit) . '</span>', $songtitle);
                }
            }
            echo $songtitle . '
                </div>
                <div class="tbl2" style="height: auto; border-radius: 0 0 5px 5px;">
                    <div>
                        <span class="small">' . $locale['SSP_264'] . " " . showdate("longdate", $data['lastupdate']) . '</span>
                    </div>
                </div>
            </div>';
        }
    } else {
        echo "<br />\n<div class='tbl-border' style='margin: 20px auto;'><div class='tbl1'>" . $locale['SSP_265'] . "</div></div>\n";
    }
}
