<?php
header("Expires: Sat, 05 Nov 2005 00:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

require(__DIR__ . "/../../../maincore.php");
require(__DIR__ . "/../infusion_db.php");

if (!checkrights("SWSS") || !defined("iAUTH") || $_GET['aid'] != iAUTH) {
	die("Access denied.");
}

if (!isset($_GET['coverid']) || !isNum($_GET['coverid']) || !isset($_GET['song']) || empty($_GET['song'])) {
	die();
}

$result = dbquery("SHOW TABLES LIKE '" . DB_STREAMSTATUS_COVERS . "'");
if (dbrows($result) == 0) {
	die();
}

$result = dbquery("SELECT * FROM `" . DB_STREAMSTATUS_COVERS . "` WHERE `ID` = '" . $_GET['coverid'] . "' LIMIT 1");
$rows = dbrows($result);
if ($rows == 0) {
	die();
} else {
	$searchsong = urldecode($_GET['song']);
	$songdata = dbarray($result);
	$new_cover = searchCoverImage();
	if (!empty($new_cover)) {
		echo $new_cover;
	}
}

function searchCoverImage() {
	global $songdata, $searchsong;
	$cover = ""; 

	// Load settings
	$result = dbquery("SELECT * FROM " . DB_STREAMSTATUS_SETTINGS);
	if (dbrows($result)) {
		while ($data = dbarray($result)) {
			$ssp_setting[$data['settings_name']] = $data['settings_value'];
		}
	}

	// prepare search string
	$invalid_str = array(" FEAT. ",	" FT. ",	" FT ",	" FEATURING ",	"&",	",",	" X "); // all upper letters!
	$replace_str = array(" ",		" ",		" ",	" ",			"",		"",		" ");
	$searchsong = str_replace($invalid_str, $replace_str, $searchsong);

	if (!empty($searchsong)) {
		$tmp = explode("-", stripslashes($searchsong));
		if (isset($tmp[1]) && !empty(trim($tmp[1]))) {
			$clean_songtitle = trim(preg_replace('/\s+/', ' ', $tmp[0] . " " . $tmp[1]));
		} else {
			$clean_songtitle = trim(preg_replace('/\s+/', ' ', str_replace("-", "", stripslashes($searchsong)))); // falls "-" am Ende steht
		}

		// search full songtitle
		$f_search = $clean_songtitle;
		$url = 'http://api.deezer.com/search?q=' . str_replace(array("(", ")"), array("", ""), urlencode($f_search)) . '&limit=1';
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0");
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
		curl_setopt($ch, CURLOPT_TIMEOUT, 10);

		$result = curl_exec($ch);
		$httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		curl_close($ch);

		if ($httpcode >= 200 && $httpcode < 300) {
			$json = json_decode($result, true);
			if ($json['total'] > 0 && $json['data']['0']['album']['title'] = $clean_songtitle) {
				// song has its own cover:
				$to_get = $json['data']['0']['album']['cover_' . $ssp_setting['cover_size']];
				$cover = file_get_contents($to_get);
			} elseif ($json['total'] > 0) {
				// no song cover, we try artist image
				$to_get = $json['data']['0']['artist']['picture_' . $ssp_setting['cover_size']];
				$cover = file_get_contents($to_get);
			}
		}

		if (empty($cover)) {
			// if we have no results until now, we try same search again without "(extended Infos)" in search string 
			$p_search = explode("(", $clean_songtitle);
			$url = 'http://api.deezer.com/search?q=' . str_replace(array("(", ")"), array("", ""), urlencode($p_search[0])) . '&limit=1';
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0");
			curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
			curl_setopt($ch, CURLOPT_TIMEOUT, 10);

			$result = curl_exec($ch);
			$httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
			curl_close($ch);

			if ($httpcode >= 200 && $httpcode < 300) {
				$json = json_decode($result, true);
				if ($json['total'] > 0 && $json['data']['0']['album']['title'] = $clean_songtitle) {
					// song has its own cover:
					$to_get = $json['data']['0']['album']['cover_' . $ssp_setting['cover_size']];
					$cover = file_get_contents($to_get);
				} elseif ($json['total'] > 0) {
					// no song cover, we try artist image
					$to_get = $json['data']['0']['artist']['picture_' . $ssp_setting['cover_size']];
					$cover = file_get_contents($to_get);
				}
			}
		}
		return (IsSet($to_get) ? $to_get : '');
	}
}
