<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: ss_functions.php
| Author: Andre Krell (systemweb.de & krelli.com)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (preg_match("/ss_functions.php/i", $_SERVER['PHP_SELF'])) { die(); }

if (!function_exists('do_ssp_update')) {
	function do_ssp_update() {
		$result = dbquery("UPDATE `" . DB_STREAMSTATUS_SETTINGS . "` SET `settings_value` = '" . STREAMSTATUS_VERSION . "' WHERE `settings_name` = 'version' LIMIT 1;");
		$result = dbquery("UPDATE `" . DB_INFUSIONS . "` SET `inf_version` = '" . STREAMSTATUS_VERSION . "' WHERE `inf_folder` = 'streamstatus_panel' LIMIT 1;");
	}
}

if(!function_exists('onlinecheck')) {
	function onlinecheck($ip, $port=21) {
		$fp = @fsockopen($ip, $port, $errno, $errstr, 5);    
		if ($fp && $errno==0) { fclose($fp); return true; }
		else { return false; }
	}
}

function sc_trans_request($ip, $port, $user, $pass, $data, $referer='') {
    $data = http_build_query($data);
    $url = parse_url($ip);
	$path = "/api";
	$fp = fsockopen($ip, $port, $errno, $errstr, 5); 
    if ($fp && $errno==0){ 
        // send the request headers:
        fputs($fp, "POST $path HTTP/1.1\r\n");
        fputs($fp, "Host: $ip\r\n");
		fputs($fp, "Authorization: Basic ".base64_encode($user.":".$pass)."\r\n");
		if ($referer != '')
            fputs($fp, "Referer: $referer\r\n");
        fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
        fputs($fp, "Content-length: ". strlen($data) ."\r\n");
        fputs($fp, "Connection: close\r\n\r\n");
        fputs($fp, $data); 
        $result = ''; 
        while(!feof($fp)) {
            // receive the results of the request
            $result .= fgets($fp, 128);
        }		
		// close the socket connection:
		fclose($fp);
    }
    else { 
        return array(
            'status' => 'err', 
            'error' => "$errstr ($errno)"
        );
    }

    $result = explode("\r\n\r\n", $result, 2); 
    $header = isset($result[0]) ? $result[0] : '';
    $content = isset($result[1]) ? $result[1] : '';
 
    // return as structured array:
    return array(
        'status' => 'ok',
        'header' => $header,
        'content' => $content
    );
    die("request done");
}

function delete_covers($interval = 25) {
	$deleted = 0;
	$tmp = dbarray(dbquery("SELECT `settings_value` FROM `" . DB_STREAMSTATUS_SETTINGS . "` WHERE `settings_name` = 'delete_covers';"));
	if ($tmp['settings_value'] > 0) { // 0 = no auto delete
		$del_before = (time() - $tmp['settings_value']);
		$result = dbquery("SELECT * FROM `" . DB_STREAMSTATUS_COVERS . "` WHERE `lastupdate` < " . $del_before . " AND `permanent` = '0' ORDER BY `lastupdate` ASC LIMIT " . $interval . ";");
		$rows = dbrows($result);
		if ($rows > 0) {
			while ($to_delete = dbarray($result)) {
				if ($to_delete['subfolder'] != "__NO-COVER") { //dont delete standard cover
					if (file_exists(__DIR__ . "/../covers/" . $to_delete['subfolder'] . "/" . $to_delete['coverimage'])) { 
						@unlink(__DIR__ . "/../covers/" . $to_delete['subfolder'] . "/" . $to_delete['coverimage']);
					}
					$result2 = dbquery("DELETE FROM `" . DB_STREAMSTATUS_COVERS . "` WHERE `ID` = " . $to_delete['ID']);
					$deleted++;
					// check if folder ist empty, if yes > delete it
					$folder_files = dbcount('(`ID`)', DB_STREAMSTATUS_COVERS, "`subfolder` = '" . $to_delete['subfolder'] . "';");
					if ($folder_files == 0 && file_exists(__DIR__ . "/../covers/" . $to_delete['subfolder'])) {
						@rmdir(__DIR__ . "/../covers/" . $to_delete['subfolder']);
					}
				}
			}
		}
	}
	return $deleted;
}

function getSongInfo($protocol, $type, $server, $port, $mountpoint = false) {
	$url = ($protocol == 'https' ? 'https://' : 'http://') . $server . ':' . $port . '/';
	if ($type == "icecast") {
		$url .= "status-json.xsl?mount=" . $mountpoint;
	} elseif ($type == 'shoutcast1') {
		$url .= '7.html';
	} elseif ($type == 'shoutcast2') {
		$url .= 'currentsong?sid=' . $mountpoint;
	} elseif ($type == 'lautfm') {
		$url = 'https://api.laut.fm/station/' . $mountpoint . '/current_song';
	} elseif ($type == 'stream24') {
		$url = 'https://player.mdn.stream24.net/webradiotoolbox/icshow.php?server='.$server.'&port='.$port.'&data=titel';
	}

	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0");
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
	curl_setopt($ch, CURLOPT_TIMEOUT, 10);

	$result = curl_exec($ch);
	$httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);

	if ($httpcode >= 200 && $httpcode < 300) {
		if ($type == 'lautfm') {
			$json = json_decode($result, true);
			$songtitle = $json['artist']['name'] . " - " . $json['title'];
		} elseif ($type == 'shoutcast1') {
			preg_match("~<body.*?>(.*?)<\/body>~is", $result, $match);
			$tmp = explode(",", $match[1]);
			$songtitle = (Is_Array($tmp) && isset($tmp[6]) ? str_replace($tmp[0] . "," . $tmp[1] . "," . $tmp[2] . "," . $tmp[3] . "," . $tmp[4] . "," . $tmp[5] . ",", "", $match[1]) : "");
		} elseif ($type == 'shoutcast2') {
			$songtitle = $result;
		} elseif ($type == 'icecast') {
			$json_a = json_decode($result, true);
			$songtitle = (Is_Array($json_a) && isset($json_a['icestats']['source']['yp_currently_playing']) ? $json_a['icestats']['source']['yp_currently_playing'] : "");
		} elseif ($type == 'stream24') {
			if(!empty($result)) {
				preg_match("/\(\'(.+)\'\)/si", $result, $matches);
				if (IsSet($matches[1])) $songtitle = str_replace("\\", "", $matches[1]);
				else return false;
			}
			else {
				return false;
			}
		}
		return $songtitle ?? false;
	} 
	else return false;
}

function getListeners($protocol,$type,$server,$port,$mountpoint=false) {
	$url = ($protocol == 'https' ? 'https://' : 'http://').$server.':'.$port.'/';
	if ($type == "icecast") { $url .= "status-json.xsl?mount=".$mountpoint; }
	elseif ($type == 'shoutcast1') { $url .= '7.html'; }
	elseif ($type == 'shoutcast2') { $url .= '7.html?sid='.$mountpoint; }
	elseif ($type == 'lautfm') { $url = 'https://api.laut.fm/station/'.$mountpoint.'/listeners'; }
	elseif ($type == 'stream24') { $url = 'https://player.mdn.stream24.net/webradiotoolbox/icshow.php?server='.$server.'&port='.$port.'&data=listener'; }
	
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0");
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
	curl_setopt($ch, CURLOPT_TIMEOUT, 10);

	$result = curl_exec($ch);
	$httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);

	if ($httpcode>=200 && $httpcode<300) {
		if ($type == 'lautfm') {
			$json = json_decode($result,true);
			$listeners = $json;
		}
		elseif ($type == 'shoutcast1' || $type == 'shoutcast2') {
			preg_match("~<body.*?>(.*?)<\/body>~is", $result, $match);
			$tmp = explode(",",$match[1]);
			$listeners = (Is_Array($tmp) ? $tmp[0] : "0");
		}
		elseif ($type == 'icecast') {
			$json_a = json_decode($result, true);
			$listeners = (Is_Array($json_a) && IsSet($json_a['icestats']['source']['listeners']) ? $json_a['icestats']['source']['listeners'] : "0");
		}
		elseif ($type == 'stream24') {
			preg_match("/\(\'(.+)\'\)/si", $result, $matches);
			$listeners = str_replace("\\", "", $matches[1]);
		}
		return $listeners;
	}
	else return '0';
}

function filter_filename($filename) {
    // sanitize filename
    $filename = preg_replace(
        '~
        [<>:"/\\\|?*]|            # file system reserved https://en.wikipedia.org/wiki/Filename#Reserved_characters_and_words
        [\x00-\x1F]|             # control characters http://msdn.microsoft.com/en-us/library/windows/desktop/aa365247%28v=vs.85%29.aspx
        [\x7F\xA0\xAD]|          # non-printing characters DEL, NO-BREAK SPACE, SOFT HYPHEN
        [#\[\]@!$&\'()+,;=]|     # URI reserved https://www.rfc-editor.org/rfc/rfc3986#section-2.2
        [{}^\~`]                 # URL unsafe characters https://www.ietf.org/rfc/rfc1738.txt
        ~x',
        '-', $filename);
    // avoids ".", ".." or ".hiddenFiles"
    $filename = ltrim($filename, '.-');
    // maximize filename length to 255 bytes http://serverfault.com/a/9548/44086
    $ext = pathinfo($filename, PATHINFO_EXTENSION);
    $filename = replaceAccents(mb_strcut(pathinfo($filename, PATHINFO_FILENAME), 0, 255 - ($ext ? strlen($ext) + 1 : 0), mb_detect_encoding($filename)) . ($ext ? '.' . $ext : ''));
    return $filename;
}

function replaceAccents($str) {
  $a = array('À', 'Á', 'Â', 'Ã', 'Ä', 'Å', 'Æ', 'Ç', 'È', 'É', 'Ê', 'Ë', 'Ì', 'Í', 'Î', 'Ï', 'Ð', 'Ñ', 'Ò', 'Ó', 'Ô', 'Õ', 'Ö', 'Ø', 'Ù', 'Ú', 'Û', 'Ü', 'Ý', 'ß', 'à', 'á', 'â', 'ã', 'ä', 'å', 'æ', 'ç', 'è', 'é', 'ê', 'ë', 'ì', 'í', 'î', 'ï', 'ñ', 'ò', 'ó', 'ô', 'õ', 'ö', 'ø', 'ù', 'ú', 'û', 'ü', 'ý', 'ÿ', 'Ā', 'ā', 'Ă', 'ă', 'Ą', 'ą', 'Ć', 'ć', 'Ĉ', 'ĉ', 'Ċ', 'ċ', 'Č', 'č', 'Ď', 'ď', 'Đ', 'đ', 'Ē', 'ē', 'Ĕ', 'ĕ', 'Ė', 'ė', 'Ę', 'ę', 'Ě', 'ě', 'Ĝ', 'ĝ', 'Ğ', 'ğ', 'Ġ', 'ġ', 'Ģ', 'ģ', 'Ĥ', 'ĥ', 'Ħ', 'ħ', 'Ĩ', 'ĩ', 'Ī', 'ī', 'Ĭ', 'ĭ', 'Į', 'į', 'İ', 'ı', 'Ĳ', 'ĳ', 'Ĵ', 'ĵ', 'Ķ', 'ķ', 'Ĺ', 'ĺ', 'Ļ', 'ļ', 'Ľ', 'ľ', 'Ŀ', 'ŀ', 'Ł', 'ł', 'Ń', 'ń', 'Ņ', 'ņ', 'Ň', 'ň', 'ŉ', 'Ō', 'ō', 'Ŏ', 'ŏ', 'Ő', 'ő', 'Œ', 'œ', 'Ŕ', 'ŕ', 'Ŗ', 'ŗ', 'Ř', 'ř', 'Ś', 'ś', 'Ŝ', 'ŝ', 'Ş', 'ş', 'Š', 'š', 'Ţ', 'ţ', 'Ť', 'ť', 'Ŧ', 'ŧ', 'Ũ', 'ũ', 'Ū', 'ū', 'Ŭ', 'ŭ', 'Ů', 'ů', 'Ű', 'ű', 'Ų', 'ų', 'Ŵ', 'ŵ', 'Ŷ', 'ŷ', 'Ÿ', 'Ź', 'ź', 'Ż', 'ż', 'Ž', 'ž', 'ſ', 'ƒ', 'Ơ', 'ơ', 'Ư', 'ư', 'Ǎ', 'ǎ', 'Ǐ', 'ǐ', 'Ǒ', 'ǒ', 'Ǔ', 'ǔ', 'Ǖ', 'ǖ', 'Ǘ', 'ǘ', 'Ǚ', 'ǚ', 'Ǜ', 'ǜ', 'Ǻ', 'ǻ', 'Ǽ', 'ǽ', 'Ǿ', 'ǿ');
  $b = array('A', 'A', 'A', 'A', 'A', 'A', 'AE', 'C', 'E', 'E', 'E', 'E', 'I', 'I', 'I', 'I', 'D', 'N', 'O', 'O', 'O', 'O', 'O', 'O', 'U', 'U', 'U', 'U', 'Y', 's', 'a', 'a', 'a', 'a', 'a', 'a', 'ae', 'c', 'e', 'e', 'e', 'e', 'i', 'i', 'i', 'i', 'n', 'o', 'o', 'o', 'o', 'o', 'o', 'u', 'u', 'u', 'u', 'y', 'y', 'A', 'a', 'A', 'a', 'A', 'a', 'C', 'c', 'C', 'c', 'C', 'c', 'C', 'c', 'D', 'd', 'D', 'd', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'G', 'g', 'G', 'g', 'G', 'g', 'G', 'g', 'H', 'h', 'H', 'h', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'IJ', 'ij', 'J', 'j', 'K', 'k', 'L', 'l', 'L', 'l', 'L', 'l', 'L', 'l', 'l', 'l', 'N', 'n', 'N', 'n', 'N', 'n', 'n', 'O', 'o', 'O', 'o', 'O', 'o', 'OE', 'oe', 'R', 'r', 'R', 'r', 'R', 'r', 'S', 's', 'S', 's', 'S', 's', 'S', 's', 'T', 't', 'T', 't', 'T', 't', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'W', 'w', 'Y', 'y', 'Y', 'Z', 'z', 'Z', 'z', 'Z', 'z', 's', 'f', 'O', 'o', 'U', 'u', 'A', 'a', 'I', 'i', 'O', 'o', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'A', 'a', 'AE', 'ae', 'O', 'o');
  return str_replace($a, $b, $str);
}

function getCoverImage($id=0) {
	// prepare search string
	$invalid_str = array("FEAT.",	" FT. ",	" FT ",	"FEATURING",	"&",	","); // all upper letters!
	$replace_str = array("",		" ",		" ",	"",				"",		"");
	
	// prepare imagefile name
	$search = array("Ä", "Ö", "Ü", "ä", "ö", "ü", "ß", "é", "è");
	$replace = array("Ae", "Oe", "Ue", "ae", "oe", "ue", "ss", "e", "e");
	
    $id = (IsSet($_GET['id']) ? intval($_GET['id']) : 0);
	$result = dbquery("SELECT `stream_currentsong`, `stream_defaultcover` FROM `" . DB_STREAMSTATUS_STREAMS . "` WHERE `ID` = '" . $id . "' LIMIT 1;");
    $rows = dbrows($result);
    if ($rows == 0) {
	    //do nothing
    } else {
	    $data = dbarray($result);
        $song = $data['stream_currentsong'];
        if ($song != "") {
		    $default_cover = $data['stream_defaultcover'];
            $cover = "";
			$song_db = addslashes(strtoupper($data['stream_currentsong']));
			$result = dbquery("SELECT `coverimage`, `subfolder` FROM `" . DB_STREAMSTATUS_COVERS . "` WHERE `songtitle` = '" . $song_db . "' LIMIT 1;");
			$rows = dbrows($result);
			if ($rows != 0) {
				$s = dbarray($result);
				$subfolder = $s['subfolder'];
				$imagefile = $s['coverimage'];
			}
			else {
				// Load settings
				$result = dbquery("SELECT * FROM " . DB_STREAMSTATUS_SETTINGS);
				if (dbrows($result)) {
					while ($data = dbarray($result)) {
						$ssp_setting[$data['settings_name']] = $data['settings_value'];
					}
				}
				$searchsong = str_replace($invalid_str, $replace_str, strtoupper($song));

				if (!empty($searchsong)) {
					$tmp = explode(" - ", stripslashes($searchsong));
					if (isset($tmp[1]) && !empty(trim($tmp[1]))) {
						$clean_songtitle = trim(preg_replace('/\s+/', ' ', $tmp[0] . " " . $tmp[1]));
					} else {
						$clean_songtitle = trim(preg_replace('/\s+/', ' ', str_replace(array("-", "_"), array("", ""), stripslashes($searchsong)))); // falls "-" am Ende steht
					}

					// search full songtitle
					$url = 'http://api.deezer.com/search?q=' . str_replace(array("(", ")", "/", ";" , "."), array("", "", " ", " ", " "), urlencode($clean_songtitle)) . '&limit=1';
					$ch = curl_init();
					curl_setopt($ch, CURLOPT_URL, $url);
					curl_setopt($ch, CURLOPT_HEADER, 0);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
					curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0");
					curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 15);
					curl_setopt($ch, CURLOPT_TIMEOUT, 15);

					$result = curl_exec($ch);
					$httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
					curl_close($ch);

					if ($httpcode >= 200 && $httpcode < 300) {
						$json = json_decode($result, true);
						if ($json['total'] > 0 && $json['data']['0']['album']['title'] = $clean_songtitle) {
							// song has its own cover:
							$to_get = $json['data']['0']['album']['cover_' . $ssp_setting['cover_size']];
							$cover = file_get_contents($to_get);

						} elseif ($json['total'] > 0) {
							// no song cover, we try artist image
							$to_get = $json['data']['0']['artist']['picture_' . $ssp_setting['cover_size']];
							$cover = file_get_contents($to_get);
						}
					}

					if (empty($cover)) {
						// if we have no results until now, we try same search again without "(extended Infos)" in search string 
						$p_search = explode("(", $clean_songtitle);
						$url = 'http://api.deezer.com/search?q=' . str_replace(array("(", ")"), array("", ""), urlencode($p_search[0])) . '&limit=1';
						$ch = curl_init();
						curl_setopt($ch, CURLOPT_URL, $url);
						curl_setopt($ch, CURLOPT_HEADER, 0);
						curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
						curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0");
						curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 15);
						curl_setopt($ch, CURLOPT_TIMEOUT, 15);

						$result = curl_exec($ch);
						$httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
						curl_close($ch);

						if ($httpcode >= 200 && $httpcode < 300) {
							$json = json_decode($result, true);
							if ($json['total'] > 0 && $json['data']['0']['album']['title'] = $clean_songtitle) {
								// song has its own cover:
								$to_get = $json['data']['0']['album']['cover_' . $ssp_setting['cover_size']];
								$cover = file_get_contents($to_get);
							} elseif ($json['total'] > 0) {
								// no song cover, we try artist image
								$to_get = $json['data']['0']['artist']['picture_' . $ssp_setting['cover_size']];
								$cover = file_get_contents($to_get);
							}
						}
					}

					if (empty($cover)) {
						// if nothing found, set default cover image
						$subfolder = "__NO-COVER";
						$imagefile = $default_cover;
					} else {
						$coverfile = explode(" - ", $song);
						if (count($coverfile) > 1) {
							$subfolder = preg_replace('/[^A-Za-z0-9ÄÖÜäöüß().\-]+/', '_', filter_filename(str_replace($search, $replace, trim($coverfile[0]))));
							$imagefile = preg_replace('/[^A-Za-z0-9ÄÖÜäöüß().\-]+/', '_', filter_filename(str_replace($search, $replace, trim($coverfile[1])))) . ".JPG";
						} else {
							$subfolder = "__NO-ARTIST";
							$imagefile = preg_replace('/[^A-Za-z0-9ÄÖÜäöüß.\-]+/', '_', filter_filename(str_replace($search, $replace, trim($coverfile[0])))) . ".JPG";
						}
					}

					$subfolder = strtoupper($subfolder);
					$imagefile = strtoupper($imagefile);

					// save data
					if($subfolder != "__NO-COVER") {
						if (!file_exists(INFUSIONS . "streamstatus_panel/covers/" . $subfolder)) {
							mkdir(INFUSIONS . "streamstatus_panel/covers/" . $subfolder);
						}
						@file_put_contents(INFUSIONS . "streamstatus_panel/covers/" . $subfolder . "/" . $imagefile, $cover);
					}
					$result = dbquery("INSERT INTO `" . DB_STREAMSTATUS_COVERS . "` 
						(songtitle, coverimage, subfolder, lastupdate) VALUES 
						('" . strtoupper(addslashes($song)) . "', '" . $imagefile . "', '" . $subfolder . "', '" . time() . "')
					");
				}
                
            }
        }
		// update db entry here to prevent long delays
		$result = dbquery("UPDATE `" . DB_STREAMSTATUS_STREAMS . "` SET 
			`stream_coverimg`= '" . $subfolder . "/" . $imagefile . "'
			WHERE `ID` = " . $_GET['id'] . " LIMIT 1");
		return strtoupper($subfolder . "/" . $imagefile);
    }
}
