<?php
/*----------------------------------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------------------------------------+
| Filename: infusion.php
| Author: Andre Krell alias Krelli (systemweb.de & krelli.com)
+----------------------------------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+----------------------------------------------------------------------------------*/
if (!defined("IN_FUSION")) {
	die();
}

require_once(__DIR__ . "/infusion_db.php");

include(SWSS_LOCALE);

$inf_title = $locale['SSP_title'];
$inf_description = $locale['SSP_desc'];
$inf_version = STREAMSTATUS_VERSION;
$inf_developer = "Andr&eacute; Krell (Krelli)";
$inf_email = "andre@krelli.com";
$inf_weburl = "https://www.krelli.com/";
$inf_folder = "streamstatus_panel";
$inf_image = 'inf.png';

$inf_adminpanel[1] = array(
	"title" => $locale['SSP_adminlink'],
	"image" => "../../infusions/".$inf_folder."/".$inf_image,
	"panel" => "administration/index.php",
	"rights" => "SWSS",
	"page"     => 5
);

$inf_newtable[1] = DB_STREAMSTATUS_SETTINGS . " (
  `settings_name` varchar(200) NOT NULL,
  `settings_value` text DEFAULT NULL,
    PRIMARY KEY (`settings_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;";

$inf_newtable[2] = DB_STREAMSTATUS_STREAMS . " (
  `ID` int(11) NOT NULL AUTO_INCREMENT,
  `stream_title` text,
  `stream_visibility` varchar(15) NOT NULL DEFAULT 'guest',
  `stream_server` varchar(200) NOT NULL DEFAULT '',
  `stream_port` int(5) UNSIGNED DEFAULT NULL,
  `stream_adminpw` varchar(50) NOT NULL DEFAULT '',
  `stream_ssl` smallint(1) UNSIGNED NOT NULL DEFAULT 0,
  `stream_type` varchar(25) NOT NULL DEFAULT '',
  `stream_id` tinyint(3) UNSIGNED NOT NULL DEFAULT 1,
  `stream_mountpoint` varchar(100) NOT NULL DEFAULT '',
  `stream_channelname` varchar(75) NOT NULL DEFAULT '',
  `stream_description` text,
  `stream_standardplayers` smallint(1) UNSIGNED NOT NULL DEFAULT 1,
  `stream_audioplayer` text,
  `stream_scheduler` varchar(50) NOT NULL DEFAULT '',
  `stream_tc_server` varchar(75) NOT NULL DEFAULT '',
  `stream_tc_adminuser` varchar(25) DEFAULT 'admin',
  `stream_tc_adminpass` varchar(50) NOT NULL DEFAULT '',
  `stream_tc_adminport` int(5) NOT NULL DEFAULT 0,
  `stream_ac_server` text,
  `stream_ac_apikey` text,
  `stream_ac_channel` int(11) NOT NULL DEFAULT 0,
  `stream_songspacer` varchar(25) NOT NULL DEFAULT '',
  `stream_wishboxlink` text,
  `stream_defaultcover` varchar(100) DEFAULT 'DEFAULT-COVER.JPG',
  `stream_currentsong` text,
  `stream_currentlisteners` int(11) UNSIGNED NOT NULL DEFAULT 0,
  `stream_currentdj` int(11) UNSIGNED NOT NULL DEFAULT 0,
  `stream_coverimg` text,
  `stream_autodj_name` varchar(50) NOT NULL DEFAULT 'Auto-DJ',
  `stream_lastrequest` int(11) UNSIGNED NOT NULL DEFAULT 0,
    PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;";

$inf_newtable[3] = DB_STREAMSTATUS_COVERS . " (
  `ID` int(11) NOT NULL AUTO_INCREMENT,
  `songtitle` varchar(100) NOT NULL DEFAULT '',
  `coverimage` varchar(150) NOT NULL DEFAULT '',
  `subfolder` varchar(100) NOT NULL DEFAULT '',
  `permanent` tinyint(1) NOT NULL DEFAULT 0,
  `lastupdate` int(11) UNSIGNED NOT NULL DEFAULT 0,
    PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;";

$inf_insertdbrow[1] = DB_PANELS . " 
(`panel_name`, `panel_filename`, `panel_content`, `panel_side`, `panel_order`, `panel_type`, `panel_access`, `panel_display`, `panel_status`, `panel_url_list`, `panel_restriction`) 
VALUES
('" . $locale['SSP_title'] . "', '".$inf_folder."', '', 4, 1, 'file', 0, 0, 1, '', 2);";

$inf_insertdbrow[2] = DB_STREAMSTATUS_SETTINGS . " (`settings_name`, `settings_value`) VALUES ('version', '".STREAMSTATUS_VERSION."');";
$inf_insertdbrow[3] = DB_STREAMSTATUS_SETTINGS . " (`settings_name`, `settings_value`) VALUES ('panel_title', '" . $locale['SSP_title'] . "');";
$inf_insertdbrow[4] = DB_STREAMSTATUS_SETTINGS . " (`settings_name`, `settings_value`) VALUES ('listeners_visibility', '0');";
$inf_insertdbrow[5] = DB_STREAMSTATUS_SETTINGS . " (`settings_name`, `settings_value`) VALUES ('enable_covers', '0');";
$inf_insertdbrow[6] = DB_STREAMSTATUS_SETTINGS . " (`settings_name`, `settings_value`) VALUES ('layout_compact', '0');";
$inf_insertdbrow[7] = DB_STREAMSTATUS_SETTINGS . " (`settings_name`, `settings_value`) VALUES ('cover_size', 'medium');";
$inf_insertdbrow[8] = DB_STREAMSTATUS_SETTINGS . " (`settings_name`, `settings_value`) VALUES ('delete_covers', '86400');";
$inf_insertdbrow[9] = DB_STREAMSTATUS_SETTINGS . " (`settings_name`, `settings_value`) VALUES ('listenerlist_visibility', 'admin');";

$inf_droptable[1] = DB_STREAMSTATUS_SETTINGS;
$inf_droptable[2] = DB_STREAMSTATUS_STREAMS;
$inf_droptable[3] = DB_STREAMSTATUS_COVERS;

$inf_deldbrow[1] = DB_PANELS . " WHERE `panel_filename`='" . $inf_folder . "'";
$inf_deldbrow[2] = DB_ADMIN." WHERE admin_rights='SWSS'";

$inf_updatedbrow[1] = DB_INFUSIONS." SET `inf_version` = '".STREAMSTATUS_VERSION."' WHERE `inf_folder` = '".$inf_folder."' LIMIT 1;";
