<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: listeners_list.php
| Author: Andre Krell | Krelli (systemweb.de | krelli.com)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once(__DIR__."/../../maincore.php");
require_once(__DIR__."/infusion_db.php");
require_once(THEMES."templates/header.php");

$streamstatus_installed = FALSE;

$result = dbquery("SHOW TABLES LIKE '" . DB_STREAMSTATUS_STREAMS . "'");
if (dbrows($result) != 0) {
	// Ok, streamstatus is infused. Now check if there is at least 1 stream defined.
	if (dbcount('(`ID`)', DB_STREAMSTATUS_STREAMS) > 0) {
		$streamstatus_installed = TRUE;
	}
}

if ($streamstatus_installed) {
	$result = dbquery("SELECT * FROM " . DB_STREAMSTATUS_SETTINGS);
	if (dbrows($result)) {
		while ($data = dbarray($result)) {
			$ssp_setting[$data['settings_name']] = $data['settings_value'];
		}
	}

	if(defined('FUSION_V7')) {
		include(SWSS_LOCALE);
	}
	else {
		$locale = fusion_get_locale('', SWSS_LOCALE);
	}
	
	if(!IsSet($ssp_setting['listenerlist_visibility'])) { $ssp_setting['listenerlist_visibility'] = 'siteadmin'; }
	$viewlistenerlist = $ssp_setting['listenerlist_visibility'];
	
	
add_to_title(" &raquo; ".$locale['SSP_300']);
					
opentable($locale['SSP_300']);
// check access rights
if ($viewlistenerlist != '0' && (iSUPERADMIN || ($viewlistenerlist == 'admin' && iADMIN) || (IsNum($viewlistenerlist) && checkgroup($viewlistenerlist)))) {
echo "<div id='listeners_list' class='text-center'></div>";
closetable();
add_to_footer("
<script>					
function loadListenersList() {
	var xmlHttp = false;
	try {
		xmlHttp  = new ActiveXObject(\"Msxml2.XMLHTTP\");
	} catch(e) {
		try {
			xmlHttp  = new ActiveXObject(\"Microsoft.XMLHTTP\");
		} catch(e) {
			xmlHttp  = false;
		}
	}
	if (!xmlHttp  && typeof XMLHttpRequest != 'undefined') {
		xmlHttp = new XMLHttpRequest();
	}

	if (xmlHttp) {
		xmlHttp.open('GET', '".$settings['siteurl']."infusions/streamstatus_panel/ajax/fetch_listeners.php', true);
		xmlHttp.onreadystatechange = function () {
			if (xmlHttp.readyState == 4) {
				document.getElementById(\"listeners_list\").innerHTML = xmlHttp.responseText;
			}
		};
		xmlHttp.send(null);
	}
}
loadListenersList();
setInterval('loadListenersList()',15000);
</script>
");
}
else {
	echo "<div class='text-center'>" . $locale['SSP_301'] . "</div>";
}
}
require_once THEMES."templates/footer.php";