<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: streamstatus_panel.php
| Author: Andre Krell | Krelli (systemweb.de | krelli.com)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) {
	die("Access Denied");
}

require(__DIR__ . "/infusion_db.php");
require(__DIR__ . "/includes/ss_functions.php");

define('SWSS_AJAX', (defined('FUSION_V7') ? $settings['siteurl'] : fusion_get_settings('siteurl')) . 'infusions/streamstatus_panel/ajax/');
$ajax_sub = '';
$jscode = "";
$streamstatus_installed = FALSE;

$result = dbquery("SHOW TABLES LIKE '" . DB_STREAMSTATUS_STREAMS . "'");
if (dbrows($result) != 0) {
	// Ok, streamstatus is infused. Now check if there is at least 1 stream defined.
	if (dbcount('(`ID`)', DB_STREAMSTATUS_STREAMS) > 0) {
		$streamstatus_installed = TRUE;
	}
}

if ($streamstatus_installed) {
	$result = dbquery("SELECT * FROM " . DB_STREAMSTATUS_SETTINGS);
	if (dbrows($result)) {
		while ($data = dbarray($result)) {
			$ssp_setting[$data['settings_name']] = $data['settings_value'];
		}
	}

	if(defined('FUSION_V7')) {
		include(SWSS_LOCALE);
	}
	else {
		$locale = fusion_get_locale('', SWSS_LOCALE);
	}

	// is an update required?
	if (defined("STREAMSTATUS_VERSION") && STREAMSTATUS_VERSION != $ssp_setting['version']) {
		do_ssp_update();
	}
	
	if(!IsSet($ssp_setting['listenerlist_visibility'])) { $ssp_setting['listenerlist_visibility'] = 'siteadmin'; }
	$viewlisteners = $ssp_setting['listeners_visibility'];
	$viewlistenerlist = $ssp_setting['listenerlist_visibility'];
	
	add_to_head("<link rel='stylesheet' href='" . INFUSIONS . "streamstatus_panel/css/streamstatus.css?v=" . @filemtime(INFUSIONS . "streamstatus_panel/css/streamstatus.css") . "'>");
	add_to_footer("<script src='" . INFUSIONS . "streamstatus_panel/streamstatus.js'></script>");

	openside($ssp_setting['panel_title']);
	// get channels
	$result = dbquery("SELECT * FROM " . DB_STREAMSTATUS_STREAMS);
	if (dbrows($result)) {
		$s_count = 0;
		while ($s_data = dbarray($result)) {	
			$jscode .= "reload_content('" . SWSS_AJAX . "fetch_streamdata.php?id=" . $s_data['ID'] . "','fetch_streamdata');\nsetInterval(\"reload_content('" . SWSS_AJAX . "fetch_streamdata.php?id=" . $s_data['ID'] . "','fetch_streamdata')\",5000);\n";
			$viewchannel = $s_data['stream_visibility'];
			$ajax_sub = ($s_data['stream_scheduler'] == "systemweb" || $s_data['stream_scheduler'] == "granade" ? $s_data['stream_scheduler'] . "/" : "");

			if ($viewchannel != '0' && (iSUPERADMIN || ($viewchannel == 'admin' && iADMIN) || ($viewchannel == 'member' && iMEMBER) || $viewchannel == 'guest' || (IsNum($viewchannel) && checkgroup($viewchannel)))) {
				$s_count++;
				echo "<div class='channelbox'>\n";
				if ($ssp_setting['layout_compact'] == '1' && $s_count == 1) {
					echo "<div style='text-align: center;'>" . $locale['SSP_nowplaying'] . "</div>\n";
					if ($ssp_setting['enable_covers'] == '1') {
						echo "<div class='cover'><img id='current_coverimage' src='" . INFUSIONS . "streamstatus_panel/covers/" . $s_data['stream_coverimg'] . "' class='cover-img' alt='Cover'></div>\n";
					}
					echo "<div class='song-title'><div class='lauftext'><span id='current_song'>&nbsp;</span></div></div>\n";
					$jscode .= "reload_content('" . SWSS_AJAX . "current_songtitle.php?id=" . $s_data['ID'] . "','current_song');\nsetInterval(\"reload_content('" . SWSS_AJAX . "current_songtitle.php?id=" . $s_data['ID'] . "','current_song')\",5000);\n" . ($ssp_setting['enable_covers'] == '1' ? "reload_content('" . SWSS_AJAX . "current_coverimage.php?id=" . $s_data['ID'] . "','current_coverimage');\nsetInterval(\"reload_content('" . SWSS_AJAX . "current_coverimage.php?id=" . $s_data['ID'] . "','current_coverimage')\",5000);\n" : "");
					// On Air DJ
					if (!empty($s_data['stream_scheduler'])) {
						echo "<div class='onair'>\n";
						echo $locale['SSP_onair'] . "<br>\n";
						echo "<div class='dj-avatar' id='current_djavatar'></div>\n";
						echo "<div class='dj-name' id='current_djname'></div>\n";

						$jscode .= "reload_content('" . SWSS_AJAX . $ajax_sub . "current_dj_avatar.php?id=" . $s_data['ID'] . "','current_djavatar');\nsetInterval(\"reload_content('" . SWSS_AJAX . $ajax_sub . "current_dj_avatar.php?id=" . $s_data['ID'] . "','current_djavatar')\",5000);\nreload_content('" . SWSS_AJAX . $ajax_sub . "current_dj_profilelink.php?id=" . $s_data['ID'] . "','current_djname');\nsetInterval(\"reload_content('" . SWSS_AJAX . $ajax_sub . "current_dj_profilelink.php?id=" . $s_data['ID'] . "','current_djname')\",5000);\n";
						echo "</div>";
					}
					// Wishbox
					echo ($s_data['stream_wishboxlink'] != "" ?
						'
					<div class="wishbox">
						<button class="button btn btn-default btn-sm" style="padding: 5px; border-radius: 5px; text-decoration: none; vertical-align: top; cursor: pointer;" onclick="popup=window.open(\'' . $s_data['stream_wishboxlink'] . '\',\'Studiobox\',\'toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=1,resizable=0,width=400,height=500,left=50,top=50\'); return false;" title="' . $locale['SSP_studiobox'] . '"><i class="fas fa-envelope-open-text"></i> ' . $locale['SSP_wishbox'] . ' </button>
					</div>
					' : '');
				}
				echo "<div class='stream-title'><strong>" . $s_data['stream_title'] . "</strong></div>\n";
				echo (!empty($s_data['stream_description']) ? "<div class='stream-description'>" . $s_data['stream_description'] . "</div>\n" : "");
				// Show listeners?
				if ($viewlisteners != '0' && (iSUPERADMIN || ($viewlisteners == 'admin' && iADMIN) || ($viewlisteners == 'member' && iMEMBER) || $viewlisteners == 'guest' || (IsNum($viewlisteners) && checkgroup($viewlisteners)))) {
					echo "<div class='listeners'>" . $locale['SSP_listeners'] . ": <span id='current_listeners_" . $s_data['ID'] . "'>0</span></div>\n";
					$jscode .= "reload_content('" . SWSS_AJAX . "current_listeners.php?id=" . $s_data['ID'] . "','current_listeners_" . $s_data['ID'] . "');\nsetInterval(\"reload_content('" . SWSS_AJAX . "current_listeners.php?id=" . $s_data['ID'] . "','current_listeners_" . $s_data['ID'] . "')\",5000);\n";
				}
				if (($s_data['stream_type'] == "shoutcast1" || $s_data['stream_type'] == "shoutcast2") && $viewlistenerlist != '0' && (iSUPERADMIN || ($viewlistenerlist == 'admin' && iADMIN) || (IsNum($viewlistenerlist) && checkgroup($viewlistenerlist)))) {
					echo "<div class='listeners-list'>[<a href='" . INFUSIONS . "streamstatus_panel/listeners_list.php'>" . $locale['SSP_300'] . "</a>]</div>\n";
				}
				// 1 Cover per Stream
				if ($ssp_setting['layout_compact'] != '1') {
					if ($ssp_setting['enable_covers'] == '1') {
						echo "<div class='cover'><img id='current_coverimage_" . $s_data['ID'] . "' src='" . INFUSIONS . "streamstatus_panel/covers/__NO-COVER/" . $s_data['stream_defaultcover'] . "' class='cover-img' alt='Cover'></div>\n";
					}
					echo "<div class='song-title lauftext'><span id='current_song_" . $s_data['ID'] . "'></span></div>\n";
					$jscode .= "reload_content('" . SWSS_AJAX . "current_songtitle.php?id=" . $s_data['ID'] . "','current_song_" . $s_data['ID'] . "');\nsetInterval(\"reload_content('" . SWSS_AJAX . "current_songtitle.php?id=" . $s_data['ID'] . "','current_song_" . $s_data['ID'] . "')\",5000);\n" . ($ssp_setting['enable_covers'] == '1' ? "reload_content('" . SWSS_AJAX . "current_coverimage.php?id=" . $s_data['ID'] . "','current_coverimage_" . $s_data['ID'] . "');\nsetInterval(\"reload_content('" . SWSS_AJAX . "current_coverimage.php?id=" . $s_data['ID'] . "','current_coverimage_" . $s_data['ID'] . "')\", 5000);\n" : "");

					// On Air DJ
					if (!empty($s_data['stream_scheduler'])) {
						echo "<div class='onair'>\n";
						echo $locale['SSP_onair'] . "<br>\n";
						echo "<div class='dj-avatar' id='current_djavatar_" . $s_data['ID'] . "'></div>\n";
						echo "<div class='dj-name' id='current_djname_" . $s_data['ID'] . "'></div>\n";
						$jscode .= "reload_content('" . SWSS_AJAX . $ajax_sub . "current_dj_avatar.php?id=" . $s_data['ID'] . "','current_djavatar_" . $s_data['ID'] . "');\nsetInterval(\"reload_content('" . SWSS_AJAX . $ajax_sub . "/current_dj_avatar.php?id=" . $s_data['ID'] . "','current_djavatar_" . $s_data['ID'] . "')\",5000);\nreload_content('" . SWSS_AJAX . $ajax_sub . "/current_dj_profilelink.php?id=" . $s_data['ID'] . "','current_djname_" . $s_data['ID'] . "');\nsetInterval(\"reload_content('" . SWSS_AJAX . $ajax_sub . "/current_dj_profilelink.php?id=" . $s_data['ID'] . "','current_djname_" . $s_data['ID'] . "')\",5000);\n";
						echo "</div>";
					}
					// Wishbox
					echo ($s_data['stream_wishboxlink'] != "" ?
						'
				<div class="wishbox">
					<button class="button btn btn-default btn-sm" style="padding: 5px; border-radius: 5px; text-decoration: none;" onclick="popup=window.open(\'' . $s_data['stream_wishboxlink'] . '\',\'Studiobox\',\'toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=1,resizable=0,width=400,height=500,left=50,top=50\'); return false;" title="' . $locale['SSP_studiobox'] . '"><i class="fas fa-envelope-open-text"></i> ' . $locale['SSP_wishbox'] . ' </button>
				</div>
				' : '');
				}
				if ($s_data['stream_standardplayers'] == '1') {
					echo "<div class='players'>" . $locale['SSP_players'] . "<br>
					<div class='playerimg'><a href='" . INFUSIONS . "streamstatus_panel/listen.php?stream_id=" . $s_data['ID'] . "&amp;type=pls' title='Winamp Player'><img src='" . INFUSIONS . "streamstatus_panel/images/winamp.png' height='50' alt='Winamp'><br><small>PLS</small></a></div>
					<div class='playerimg'><a href='" . INFUSIONS . "streamstatus_panel/listen.php?stream_id=" . $s_data['ID'] . "&amp;type=m3u' title='VLC Player'><img src='" . INFUSIONS . "streamstatus_panel/images/vlcplayer.png' height='50' alt='VLC Mediaplayer'><br><small>M3U</small></a></div>
					<div class='playerimg'><a href='" . INFUSIONS . "streamstatus_panel/listen.php?stream_id=" . $s_data['ID'] . "&amp;type=asx' title='Windows Mediaplayer'><img src='" . INFUSIONS . "streamstatus_panel/images/mediaplayer.png' height='50' alt='Windows Media Player'><br><small>ASX</small></a></div>
					<!--<div class='playerimg'><a href='#' onclick='popup=window.open(\"" . INFUSIONS . "streamstatus_panel/player/\",\"Radioplayer\",\"toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=1,resizable=0,width=550,height=250,left=50,top=50\"); return false;' title='Audio Player'><img src='" . INFUSIONS . "streamstatus_panel/images/player.png' height='50' alt='Audio Player'><br><small>Browser</small></a></div>//-->
				</div>
				";
				}
				if (!empty($s_data['stream_audioplayer'])) {
					echo "<div class='external-player'>
					<img style='cursor: pointer;' src='" . INFUSIONS . "streamstatus_panel/images/play-button.svg' height='100' alt='Im Browser abspielen' onClick='window.open(\"" . $s_data['stream_audioplayer'] . "\");'><br>
					<a href='" . $s_data['stream_audioplayer'] . "' target='_blank' title='Browser Player'>" . $locale['SSP_tunein'] . "</a>
				</div>
				";
				}
				echo "</div>\n";
			}
		}
	}

	/*
	Please keep this notice unchanged!
	*/
	echo "
	<div style='display: block; width: 100%; text-align: right; font-size: 8pt;'><a style='text-decoration: none;' href='https://www.krelli.com/' target='_blank' title='Streamstatus v" . $ssp_setting['version'] . " by Krelli'>&copy;</a></div>\n";

	closeside();

	add_to_footer("<script>\n" . $jscode . "\n</script>\n");
}


